;ͻ
;Metal Warrior III by Cadaver: Communication routines + special actor         
;routines                                                                     
;Started in 8/2000!                                                           
;ͼ

ar_jetbike:     ldy #ACTI_PLAYER
                jsr checkcollision
                bcs arjb_nocoll
                lda #DOOR_FLIGHTLEVEL
                sta enterdoornum
arjb_nocoll:    rts

ar_truck:       ldy #ACTI_PLAYER
                jsr checkcollision
                bcs artruck_nocoll
                lda actxl,x
                sec
                sbc actxl,y
                sta temp1
                lda actxh,x
                sbc actxh,y
                bmi artruck_nocoll
                cmp #>320
                bne artruck_nocoll
                lda temp1
                cmp #<320
                bcc artruck_nocoll
                lda actyl,x
                sec
                sbc actyl,y
                sta temp1
                lda actyh,x
                sbc actyh,y
                bne artruck_nocoll
                lda temp1
                cmp #10*8
                bcc artruck_nocoll
                lda #DOOR_BASE                  ;Truck will take player to base
                sta enterdoornum
artruck_nocoll: inc actfd,x
                lda actfd,x
                lsr
                lsr
                and #$01
                sta actf,x
                lda #10
                jmp moveactorxdirect

ar_introflame:  lda #PB_FLAMES
                jsr checkplotbit
                bcc arifl_remove
                lda timemin
                lsr
                lsr
                lsr
                lsr
                lsr
                sta temp1
                jsr random
                and #$03
                cmp #$03
                bcc arifl_frameok
                lda #$00
arifl_frameok:  clc
                adc temp1
                sta actf,x
                rts
arifl_remove:   jmp removeactor

ar_customer:    ldy #ACTI_PLAYER
                jsr checkcollision
                bcs arcus_nocoll
                lda actt,x
                adc #NPCI_CUSTOMER1-ACT_CUSTOMER1
                sta npccollnum
                stx npccollindex
arcus_nocoll:   lda actattk,x
                bne arcus_initted
                jsr random
                ora #$80
                sta actfd,x
                sta actattk,x
arcus_initted:  dec actfd,x
                bne arcus_animdone
                ldy actf,x
                cpy #$03
                beq arcus_reinit
                inc actf,x
                lda #$08
                cpy #$01
                bne arcus_notlonger
                lda #$14
arcus_notlonger:sta actfd,x
arcus_animdone: rts
arcus_reinit:   jsr random
                ora #$80
                sta actfd,x
                lda #$00
                sta actf,x
                rts

ar_militarynpc: ldy #ACTI_PLAYER
                jsr checkcollision
                bcs armnpc_nocoll
                lda actt,x
                adc #NPCI_COLONEL-ACT_COLONEL
                sta npccollnum
                stx npccollindex
ar_militarynpc2:
armnpc_nocoll:  ldy #ACTI_PLAYER
                jsr getactorxdist
                cmp #$02
                bcs armnpc_handsdown
                ldy invselect
                lda invtype,y
                cmp #ITEM_LASTWEAPON+1
                bcs armnpc_handsdown
                cmp #ITEM_PISTOL
                bcc armnpc_handsdown
armnpc_handsup: lda #$01
                bne armnpc_frameok
armnpc_handsdown:lda #$00
armnpc_frameok: sta actf,x
                rts

ar_npc:         ldy #ACTI_PLAYER
                jsr checkcollision
                bcs arnpc_nocoll
                lda actt,x
                adc #NPCI_HAMMER-ACT_HAMMER
                sta npccollnum
                stx npccollindex
arnpc_nocoll:   lda actt,x
                cmp #ACT_SNAKE
                bne arnpc_notsnake
                lda #PB_GEARRETURNED
                jsr checkplotbit
                bcc arnpc_notsnake
                lda #$01
                sta actf,x
arnpc_notsnake: rts

ar_band:        inc actfd,x
                lda actfd,x
                and #$03
                bne ar_bandok
                lda actf,x
                clc
                adc #$01
                and #$03
                sta actf,x
ar_bandok:      rts

ar_sexrobot:    lda actfd,x
                bne ar_srwait
                jsr random
                and #$0f
                ora #$07
                sta actfd,x
                jsr random
                and #$07
                sta actf,x
                rts
ar_srwait:      dec actfd,x
                rts


ar_shopkeeper:  lda actf,x
                cmp #NPCI_GYMKEEPER
                beq ar_gymkeeper
                cmp #NPCI_GYMKEEPER2
                beq ar_gymkeeper
ar_npccommon:   ldy #ACTI_PLAYER
                jsr checkcollision
                bcs arshop_nocoll
                lda actf,x
                sta npccollnum
                stx npccollindex
arshop_nocoll:  rts

ar_gymkeeper:   lda actyh,x                     ;If player on lower level, do
                cmp actyh+ACTI_PLAYER           ;nothing
                bcc ar_gymok
                bne ar_gymcheck
                lda actyl+ACTI_PLAYER
                bne ar_gymok
ar_gymcheck:    lda actattk,x                   ;Unpaid?
                bne ar_gymok
                jsr ar_preventplayer
ar_gymok:       jmp ar_npccommon

;Ŀ
;RUNSCRIPT                                                                    
;                                                                             
;Runs a script. :-)                                                           
;                                                                             
;Parameters: A,X:Script address                                               
;Returns: -                                                                   
;Modifies: A,X,Y, lots of temp variables :-)                                  
;

runscript:      sta npcptrlo
                stx npcptrhi
                jmp comm_scriptloop

;Ŀ
;COMMROUTINE                                                                  
;                                                                             
;Communication with NPCs.                                                     
;                                                                             
;Parameters: -                                                                
;Returns: -                                                                   
;Modifies: A,X,Y, lots of temp variables :-)                                  
;

commroutine:    ldx commnum
                lda npctbllo-1,x
                sta npcptrlo
                lda npctblhi-1,x
                sta npcptrhi
                lda npctypetbl-1,x
                bmi comm_shop
comm_scriptloop:ldy #$00
                lda (npcptrlo),y                ;Get script command
                tax
                lda scripttbllo,x
                sta comm_scriptjsr+1
                lda scripttblhi,x
                sta comm_scriptjsr+2
                iny
                lda (npcptrlo),y                ;Get first parameter to A
comm_scriptjsr: jsr $0000                       ;Execute command
                tya
                clc
                adc npcptrlo
                sta npcptrlo
                bcc comm_scriptloop
                lda npcptrhi
                adc #$00
                sta npcptrhi
                bne comm_scriptloop

comm_shop:      ldy #$00
                sty shopselect
                lda (npcptrlo),y
                sta msgptrlo
                iny
                lda (npcptrlo),y                ;If message pointer is zero,
                beq shop_loop                   ;skip the message
                sta msgptrhi
                lda #$ff
                sta msgtime
                jsr newmessage2
                jsr comm_waitfire
shop_loop:      jsr shop_gettype
                bne shop_noexittext
                lda #<exittext
                ldx #>exittext
                jmp shop_buymsgcommon
shop_noexittext:tax
                lda itemnametbllo,x
                sta shop_itemname+1
                lda itemnametblhi,x
                sta shop_itemname+2
                ldx #$00
shop_itemname:  lda $1000,x
                beq shop_itemnameend
                sta buytext,x
                inx
                bne shop_itemname
shop_itemnameend:
                cpx #ITEMNAMELENGTH
                bcs shop_itemnamedone
                lda #$20
                sta buytext,x
                inx
                bne shop_itemnameend
shop_itemnamedone:
                iny
                ldx #$03
                lda #$20
shop_clearammo: sta buytext+16,x
                dex
                bpl shop_clearammo
                lda (npcptrlo),y                ;Ammo
                beq shop_zeroammo
                ldx #17
                jsr shop_print2digits
                lda #"("
                sta buytext+16
                lda #")"
                sta buytext+19
shop_zeroammo:  iny
                lda (npcptrlo),y                ;Price low
                sta pricelo
                ldx #27
                jsr shop_print2digits
                iny
                lda (npcptrlo),y                ;Price high
                sta pricehi
                ldx #25
                jsr shop_printdigit
                lda #$00                        ;Assume: no credits
                sta creditslo
                sta creditshi
                lda #ITEM_CREDITS
                jsr finditem
                bcc shop_nocredits2
                lda invammolo,y
                sta creditslo
                lda invammohi,y
                sta creditshi
shop_nocredits2:ldx #39
                lda creditslo
                jsr shop_print2digits
                ldx #37
                lda creditshi
                jsr shop_printdigit
                lda #<buytext
                ldx #>buytext
shop_buymsgcommon:
                ldy #$ff
                jsr newmessage
                jsr instantmessage
shop_controlloop:
                jsr waitandupdate_notoggle
                jsr getfireclick
                bcs shop_buyorexit
                lda prevjoy
                bne shop_controlloop
                lda joystick
                and #JOY_RIGHT+JOY_DOWN
                beq shop_notright
                jsr shop_gettype
                bne shop_notrightwrap
                sta shopselect
shop_selectdone:lda #SFX_SELECT
                jsr playsfx
                jmp shop_loop
shop_notrightwrap:
                inc shopselect
                bpl shop_selectdone
shop_notright:  lda joystick
                and #JOY_LEFT+JOY_UP
                beq shop_controlloop
                lda shopselect
                bne shop_notleftwrap
shop_leftwraploop:
                inc shopselect
                jsr shop_gettype
                bne shop_leftwraploop
                beq shop_selectdone
shop_notleftwrap:
                dec shopselect
                bpl shop_selectdone
shop_buyorexit: jsr shop_gettype
                bne shop_buy
                jmp removemessage
shop_buy:       tax
                lda creditshi
                cmp pricehi
                bcc shop_nocredits
                bne shop_buyok
                lda creditslo
                cmp pricelo
                bcc shop_nocredits
shop_buyok:     iny
                lda (npcptrlo),y                ;Ammo
                bne shop_notzeroammo2           ;If it's a zero-ammo item
                pha                             ;(all weapons)
                txa                             ;then check for duplicate
                jsr finditem
                pla                             ;If already exists, don't buy
                bcs shop_nocredits
shop_notzeroammo2:
                jsr additem
                bcc shop_noroom
                lda #ITEM_CREDITS               ;Credits should be found,
                jsr finditem                    ;but if they aren't, hmm...
                bcc shop_weirdfuckup
                sed
                lda invammohi,y                 ;Decreaseammo doesn't
                sec                             ;handle values higher than 99
                sbc pricehi                     ;so must subtract the
                sta invammohi,y                 ;highbyte here...
                cld
                lda pricelo                     ;Then the lowbyte
                jsr decreaseammo
shop_weirdfuckup:
                lda #SFX_POWERUP
shop_sfxcommon: jsr playsfx
                jmp shop_loop
shop_nocredits:
shop_noroom:    lda #SFX_HIT                    ;Play an "ugly" sound effect
                bne shop_sfxcommon

shop_print2digits:
                pha
                lsr
                lsr
                lsr
                lsr
                ora #$30
                sta buytext,x
                pla
shop_printdigit:and #$0f
                ora #$30
                sta buytext+1,x
                rts

shop_gettype:   lda shopselect
                asl
                asl
                tay
                iny
                iny
                lda (npcptrlo),y                ;Item type
                rts

comm_waitfire:  jsr waitandupdate_notoggle
                jsr getfireclick
                bcc comm_waitfire
                jmp removemessage

sr_quit:        pla
                pla
                rts

sr_text:        pha
                iny
                lda (npcptrlo),y
                tax
                pla
                ldy #$ff
                jsr newmessage
                jsr comm_waitfire
                jsr removemessage
                ldy #$03
                rts

sr_clearplotbit:jsr clearplotbit
                iny
                rts

sr_setplotbit:  jsr setplotbit
                iny
                rts

sr_toggleplotbit:jsr toggleplotbit
                iny
                rts

sr_checkplotbit:jsr checkplotbit
sr_storeresult: rol
                and #$01
                sta sresult
                iny
                rts

sr_checkitem:   jsr finditem
                ldy #$01
                jmp sr_storeresult

sr_branchiftrue:ldx sresult
                bne sr_jump
                ldy #$03
                rts

sr_branchiffalse:ldx sresult
                beq sr_jump
                ldy #$03
                rts

sr_jump:        pha
                iny
                lda (npcptrlo),y
                sta npcptrhi
                pla
                sta npcptrlo
                ldy #$00
                rts

sr_subcredits:  sta temp1
                lda #ITEM_CREDITS
                jsr finditem
                bcc sr_subnocredits2
                lda invammohi,y
                bne sr_subcreditsok
                lda invammolo,y
                cmp temp1
sr_subnocredits2:
                lda #$00
                bcc sr_subnocredits
sr_subcreditsok:lda temp1
                jsr decreaseammo
                lda #$01
sr_subnocredits:sta sresult
                ldy #$02
                rts

sr_callcode:    sta sr_callcodejsr+1
                iny
                lda (npcptrlo),y
                sta sr_callcodejsr+2
sr_callcodejsr: jsr $0000
                sta sresult
                ldy #$03
                rts

sr_poke:        tax
                iny
                lda (npcptrlo),y
                sta sr_pokesta+2
                iny
                lda (npcptrlo),y
sr_pokesta:     sta $1000,x
                iny
                rts

sr_query:       pha
                iny
                lda (npcptrlo),y
                tax
                pla
                ldy #$ff
                jsr newmessage
                ldy #$03
                lda (npcptrlo),y
                sta textptrlo
                iny
                lda (npcptrlo),y
                sta textptrhi
                ldx #11
                ldy #21
                jsr printtext
                iny
                jsr printtext
                lda #$00
                sta sresult
sr_queryloop:   jsr waitandupdate_notoggle
                lda #32
                ldx #93
                ldy sresult
                bne sr_querylower
                lda #93
                ldx #32
sr_querylower:  sta textscreen+21*40+10
                stx textscreen+22*40+10
                jsr getfireclick
                bcs sr_querydone
                lda prevjoy
                bne sr_queryloop
                lda joystick
                and #JOY_UP+JOY_DOWN+JOY_LEFT+JOY_RIGHT
                beq sr_queryloop
                lda sresult
                eor #$01
                sta sresult
                bpl sr_queryloop
sr_querydone:   jsr removemessage
                ldy #$05
                rts

sr_checktm:     tax
                lda tmstat,x
                sta sresult
                iny
                rts

sr_createactor: jsr sr_createactorsub
                jsr createactor
                ldy #$06
                rts

sr_createactorsub:
                sta temp1
                iny
                lda (npcptrlo),y
                sta temp2
                iny
                lda (npcptrlo),y
                sta temp3
                iny
                lda (npcptrlo),y
                sta temp4
                iny
                lda (npcptrlo),y
                sta temp5
                iny
                lda (npcptrlo),y
                sta temp6
                rts

sr_jointeam:    tax
                lda #STAT_ACTIVE
                sta tmstat,x
                jsr itemcapacity
                ldy #$02
                rts

sr_deleteactor: jsr findactor
                bcc sr_ddone
                lda #$00
                sta actt,x
                sta acthp,x
                lda #$ff
                sta actorg,x
sr_ddone:       ldy #$02
                rts

findactor:      sta temp1
                ldx #MAXACT-1
fa_loop:        lda actt,x
                cmp temp1
                beq fa_found
                dex
                bpl fa_loop
                clc
                rts
fa_found:       sec
                rts

sr_addscore:    jsr addscore
                lda #SFX_POWERUP
                jsr playsfx
                ldy #$02
                rts

sr_additem:     tax
                lda #$00
                jsr additem
                ldy #$02
                rts

sr_removeitem:  jsr finditem
                bcc sr_rmitemdone
                jsr removeitem
sr_rmitemdone:  ldy #$02
                rts

sr_checkcurrenttm:
                cmp teammember
                beq sr_cctfound
                lda #$00
                beq sr_cctnotfound
sr_cctfound:    lda #$01
sr_cctnotfound: sta sresult
                iny
                rts

sr_runcutscene: sta temp1
                pla
                pla
                lda temp1
runcutscene:    clc
                adc #FIRSTCUTSCENEFILE
                pha
                jsr cleartextscreen
                jsr fademusic_nowait
                pla
                jsr loadfile
                lda #$ff
                sta loadedlevel
                sta loadedsprites
                sta loadedtm
                lda #<cutscene
                ldx #>cutscene
                jmp runscript

sr_playtune:    jsr playtune
                ldy #$02
                rts

sr_initbitmapmode:
                jsr setbitmapmode
                ldy #$01
                rts

sr_drawbitmap:  jsr sr_createactorsub
                jsr drawbitmap
                ldy #$07
                rts

sr_cutscenetext:sta textptrlo
                iny
                lda (npcptrlo),y
                sta textptrhi
                iny
                lda (npcptrlo),y
                sta mapptrhi
                iny
sr_cstback:     lda (npcptrlo),y
                sta mapptrlo
sr_cstloop:     jsr waitandupdate_notoggle
                jsr getfireclick
                bcs sr_breakcutscene2
                ldy #$00
                lda (textptrlo),y
                beq sr_cstnextrow
                ldx mapptrlo
                ldy mapptrhi
                jsr drawsprchar
                inc mapptrlo
                inc textptrlo
                bne sr_cstloop
                inc textptrhi
                bne sr_cstloop
sr_cstnextrow:  iny
                lda (textptrlo),y
                beq sr_cstready
                inc mapptrhi
                ldy #$04
sr_inctextptr:  inc textptrlo
                bne sr_cstback
                inc textptrhi
                bne sr_cstback
sr_cstready:    ldy #$05
                rts

sr_breakcutscene:
                pla
                pla
sr_breakcutscene2:
                pla
                pla
                jsr fademusic
                jmp cleartextscreen

sr_delay:       pha
                lda #25
sr_delayinner:  pha
                jsr waitandupdate_notoggle
                jsr getfireclick
                bcs sr_breakcutscene
                pla
                sec
                sbc #$01
                bne sr_delayinner
                pla
                sec
                sbc #$01
                bne sr_delay
                ldy #$02
                rts

sr_endscroll:   lda #68
                jsr sbmm_setsprites2
                lda #<endtext
                sta textptrlo
                lda #>endtext
                sta textptrhi
                lda #$00
                sta mapptrlo
sr_endscrollloop:
                jsr waitandupdate_notoggle
                ldy #$03
sr_enddelayloop:jsr waitpanel
                dey
                bne sr_enddelayloop
                jsr getfireclick
                bcs sr_endscrollend
                ldy #$00
                lda (textptrlo),y
                bmi sr_endscrollloop
                jsr spritescrollroutine
                jsr waitpanel
                inc mapptrlo
                lda mapptrlo
                cmp #$07
                bcs sr_newrow
                jmp sr_endscrollloop
sr_newrow:      jsr sr_drawnewrow
                jmp sr_endscrollloop
sr_endscrollend:ldy #$01
                rts

sr_drawnewrow:  lda #$00
                sta mapptrlo
                ldy #$00
sr_findlength:  lda (textptrlo),y
                beq sr_findlengthdone
                iny
                bne sr_findlength
sr_findlengthdone:
                tya
                lsr
                clc
                eor #$ff
                adc #13
                sta temp3
sr_newrowloop:  ldy #$00
                lda (textptrlo),y
                inc textptrlo
                bne sr_newrowok
                inc textptrhi
                bne sr_newrowok
sr_newrowok:    tax
                beq sr_newrowend
                ldx temp3
                ldy #15
                jsr drawsprchar
                inc temp3
                jmp sr_newrowloop

sr_fadetune:    jsr fademusic
                ldy #$01
sr_newrowend:   rts

sr_clearcutscenetext:
                jsr clearcutscenesprites
                ldy #$01
                rts

sr_clearcutscenebitmap:
                jsr clearcutscenebitmap
                ldy #$01
                rts

gymkeeper_checkifpaid:
                ldx npccollindex
                lda actattk,x
                rts
gymkeeper_setpaidstate:
                ldx npccollindex
                inc actattk,x
                rts

snake_redraw:   jsr cleartextscreen
                jsr drawscreen
                lda #ACT_SNAKE
                jsr findactor
                jsr ar_npc
                jsr drawactors
                jmp sortsprites

snake_waitonehour:
                lda #60
                jmp gym_delaysubroutine


