;ͻ
;Metal Warrior III by Cadaver                                                 
;Control (joystick & keys) routines                                           
;ͼ

;Ŀ
;GETCONTROLS:                                                                 
;                                                                             
;Reads joystick + scans the keyboard.                                         
;                                                                             
;Parameters: -                                                                
;Returns: -                                                                   
;Modifies: A                                                                  
;

getcontrols:    lda #$ff
                sta $dc00
                lda joystick
                sta prevjoy
                lda $dc00
                eor #$ff
                sta joystick

;Ŀ
;SCANKEYS                                                                     
;                                                                             
;Reads keyboard.                                                              
;                                                                             
;Parameters: -                                                                
;Returns: -                                                                   
;Modifies: A,X,Y,temp6                                                        
;

scankeys:       lda #$ff
                sta keytype
                ldy #$07
sk_rowloop:     ldx keyrowbit,y
                stx $dc00
                ldx $dc01
                stx keyrowtbl,y
                cpx #$ff
                beq sk_rowempty
                tya
sk_rowempty:    dey
                bpl sk_rowloop
                tax
                bmi sk_nokey
                asl
                asl
                asl
                sta temp6
                ldy #$07
                lda keyrowtbl,x
sk_colloop:     asl
                bcc sk_keyfound
                dey
                bpl sk_colloop
sk_keyfound:    tya
                ora temp6
                cmp keypress
                beq sk_samekey
                sta keytype
                sta keypress
sk_samekey:

;Ŀ
;KEYCONTROL                                                                   
;                                                                             
;"Joystick" control with keyboard, with keys Q W E and SHIFT for fire.        
;                                            A   D                            
;                                            Z X C                            
;                                                                             
;                                                                             
;Parameters: -                                                                
;Returns: -                                                                   
;Modifies: A,X,Y,temp6                                                        
;

keycontrol:     ldx #$09
kcloop:         ldy kcrownum,x
                lda keyrowtbl,y
                and kcrowand,x
                beq kcpressed
kcnext:         dex
                bpl kcloop
                rts
kcpressed:      lda joystick
                ora kcjoybits,x
                sta joystick
                bne kcnext
sk_nokey:       sta keypress
                rts

;Ŀ
;GETFIRECLICK                                                                 
;                                                                             
;Checks if fire button has been pressed shortly.                              
;                                                                             
;Parameters: -                                                                
;Returns: C=0 not pressed, C=1 pressed                                        
;Modifies: A                                                                  
;

getfireclick:   clc
                lda prevjoy
                and #JOY_FIRE
                bne gfc_not
                lda joystick
                and #JOY_FIRE
                beq gfc_not
                sec
gfc_not:        rts

