;ͻ
;Metal Warrior III by Cadaver: Enemy routines                                 
;Started in 7/2000!                                                           
;ͼ

GUNMANATTKPR    = $06
KNIFEMANATTKPR  = $08
ANARCHISTATTKPR = $06
SHOTGUNMANATTKPR = $03
UZIMANATTKPR    = $04
GRENADEMANATTKPR = $02
GANGLEADERATTKPR = $08
PIGJUMPPR       = $10
RATMOVEPR       = $20
RATJUMPPR       = $05
AIRPLANEATTKPR  = $05
AIRPLANETURNPR  = $06
SOLDIER2ATTKPR  = $09
HAWKTURNPR      = $05
DOGATTKPR       = $30
JETBIKEATTKPR   = $04
HELICOPTERATTKPR = $05
HELICOPTERMISSPR = $01
GUARD1ATTKPR    = $06
GUARD2ATTKPR    = $0a
BIGROBOTJUMPPR  = $02
BIGROBOTTURNPR  = $30
BIGROBOTATTKPR  = $1c
GENERALATTKPR   = $0c

;Ŀ
;GUNMAN move routine                                                          
;

ar_gunman:      lda actbits,x                   ;On ground or jumping?
                and #AB_JUMP
                beq argunm_onground
enemyjump:      lda #1
                ldy #3*8
                jsr accactory
                lda #$00
                sta temp3
                jsr checkjumpobst               ;Perform X-movement and check
                bcc argunm_jnoobst
                lda #$00
                sta actsx,x
                jsr reverseactor
argunm_jnoobst: lda actsy,x
                bpl argunm_noheadbump
                jsr moveactory
                jmp checkheadbump
argunm_noheadbump:
                jsr checklanding2               ;obstacles, also check
                bcs argunm_landed               ;"diagonal" landing :-)
                jsr moveactory
                jsr checklanding
                bcc argunm_notlanded
argunm_landed:  lda #$00
                sta actf,x
                sta actattkd,x
                lda actsx,x                     ;Halve X-speed
                tay
                asl
                tya
                ror
                sta actsx,x
argunm_notlanded:
                rts
argunm_onground:lda actattkd,x
                beq argunm_attackok
                dec actattkd,x
enemybrake:
argunm_brake:   lda #$07
                sta actf,x
enemybrake2:    lda #$06
                jsr brakeactorx
                jmp argunm_move
argunm_attackok:jsr random                      ;Random decision for attack
                cmp #GUNMANATTKPR
                bcs argunm_attackdone
                ldy #ACTI_PLAYER
                jsr faceactor
                eor actd,x
                and #$80
                bne argunm_attackdone           ;If not facing player, don't
                jsr getactorydist               ;attack
                cmp #$01                        ;Check that Y-distance is not
                bcs argunm_attackdone           ;big (in blocks)
                jsr getactorxdist
                cmp #$01                        ;Check that X-distance is big
                bcc argunm_attackdone           ;enough
                lda #$00                        ;Aim straight
                ldy #BLT_PISTOL
                jsr actorshoot
                jmp argunm_brake
argunm_attackdone:
                lda actd,x
                bmi argunm_left
argunm_right:   lda #2
                ldy #12                         ;Max speed = 1,5 pixels
                bne argunm_anim
argunm_left:    lda #-2
                ldy #-12
enemyanim:
argunm_anim:    jsr accactorx
                lda actsx,x
                bpl argunm_spdpos
                clc
                eor #$ff
                adc #$01
argunm_spdpos:  asl
                adc #$20
                adc actfd,x
                sta actfd,x
                bcc argunm_move
                lda actf,x
                adc #$00                        ;Carry = 1, add one less
                cmp #$06
                bcc argunm_animnotover
                lda #$00
argunm_animnotover:
                sta actf,x
enemymove:
argunm_move:    jsr checksideobst
                bcs argunm_reverse
                ldy actt,x
                lda enemyfollow-ACT_FIRSTENEMY,y
                beq argunm_downstairs
                lda actyh,x
                cmp actyh+ACTI_PLAYER
                bcc argunm_downstairs
                jsr checkstairs_preferup
                bcs argunm_done
                bcc argunm_nostairs
argunm_downstairs:
                jsr checkstairs
                bcs argunm_done
argunm_nostairs:lda actsx,x                     ;Speed & direction same sign?
                eor actd,x
                and #$80
                beq argunm_jump
argunm_fall:    lda #8
                sta actsy,x
                ldy actt,x
argunm_fall2:   lda enemyjumpframe-ACT_FIRSTENEMY,y
                sta actf,x
                lda actbits,x
                ora #AB_JUMP
                sta actbits,x
                rts
enemystartjump:
argunm_jump:    ldy actt,x
                lda enemyjumpspeed-ACT_FIRSTENEMY,y ;thru walls in the beginning
                beq argunm_turnatedge
                sta actsy,x
                lda #-1                         ;Lift enemy just off the
                jsr moveactorydirect            ;ground to prevent going
                jmp argunm_fall2
argunm_turnatedge:
                jsr cso_restorepos
argunm_reverse: lda actsx,x                     ;Reverse direction only if
                eor actd,x                      ;speed & direction have same
                and #$80                        ;sign
                bne argunm_noreverse
                jsr reverseactor
argunm_noreverse:
                lda #$00                        ;Then zero X-speed
                sta actsx,x
argunm_done:    rts

;Ŀ
;KNIFEMAN move routine                                                        
;

ar_knifeman:    lda actbits,x
                and #AB_JUMP
                beq arknfm_onground
                jmp enemyjump
arknfm_onground:lda actattkd,x
                beq arknfm_attackok
                dec actattkd,x
                cmp #$06
                bne arknfm_noattkanim
                lda #$07
                sta actf,x
arknfm_noattkanim:
                jmp enemybrake2
arknfm_attackok:jsr random                      ;Random decision for attack
                cmp #KNIFEMANATTKPR
                bcs arknfm_attackdone
                ldy #ACTI_PLAYER
                jsr getactorxdist
                cmp #$01                        ;Check that X-distance is not
                bcs arknfm_attackdone           ;big
                jsr reverseifneeded             ;If not facing player, turn
                bcs arknfm_attackdone
arknfm_rightdir:jsr getactorydist
                cmp #$01                        ;Check that Y-distance is not
                bcs arknfm_attackdone           ;big (in blocks)
                lda #SFX_MELEE
                jsr playsfx
                lda #$00
                ldy #BLT_KNIFEHIT
                jsr actorshoot
                lda #$08
                sta actf,x
                sta actattkd,x
                jmp enemybrake2
arknfm_attackdone:
                lda actd,x
                bmi arknfm_left
arknfm_right:   lda #2
                ldy #13
                bne arknfm_anim
arknfm_left:    lda #-2
                ldy #-13
arknfm_anim:    jmp enemyanim

;Ŀ
;ANARCHIST move routine                                                       
;

ar_anarchist:   lda actbits,x
                and #AB_JUMP
                beq aranarc_onground
                jmp enemyjump
aranarc_onground:
                lda actattkd,x
                beq aranarc_attackok
                dec actattkd,x
                jmp enemybrake
aranarc_attackok:
                lda actattk,x                  ;Molotov cocktails left?
                cmp #$03
                bcs aranarc_attackdone
                jsr random                      ;Random decision for attack
                cmp #ANARCHISTATTKPR
                bcs aranarc_attackdone
                inc actattk,x
                lda #$00
                ldy #BLT_MOLOTOV
                jsr actorshoot
                jmp enemybrake
aranarc_attackdone:
                lda actd,x
                bmi aranarc_left
aranarc_right:  lda #3
                ldy #11
                bne aranarc_anim
aranarc_left:   lda #-3
                ldy #-11
aranarc_anim:   jmp enemyanim

;Ŀ
;MOTORIST move routine                                                        
;

ar_motorist:    ;ldy #ACTI_PLAYER
                ;jsr faceactor
                ;eor actd,x
                ;and #$80
                ;bne armotor_nocoll
                inc actattk,x
                lda actattk,x
                cmp #$03
                bcc armotor_nocoll
                lda #$00
                sta actattk,x
                lda #20                         ;Check collision to player;
                sta atsizeu+ACT_MOTORIST-1      ;use only the bike size
                lda #$01                        ;Do 1 point of damage
                jsr playerenemycoll
                lda #36
                sta atsizeu+ACT_MOTORIST-1      ;Then restore size to normal
armotor_nocoll: lda actbits,x
                and #AB_JUMP
                beq armotor_onground
                jmp enemyjump
armotor_onground:
                lda actd,x
                bmi armotor_left
armotor_right:  lda #4
                ldy #24                         ;Max speed = 3 pixels
                bne armotor_move
armotor_left:   lda #-4
                ldy #-24
armotor_move:   jsr accactorx
                jmp enemymove

;Ŀ
;SHOTGUNMAN move routine                                                      
;

ar_shotgunman:  lda actbits,x
                and #AB_JUMP
                beq arsgm_onground
                jmp enemyjump
arsgm_onground: lda actattkd,x
                beq arsgm_attackok
                dec actattkd,x
                jmp enemybrake
arsgm_attackok:
arsgm_attackok: jsr random                      ;Random decision for attack
                cmp #SHOTGUNMANATTKPR
                bcs arsgm_attackdone
                jsr reverseifneeded
                bcs arsgm_attackdone
                jsr getactorydist
                cmp #$02                        ;Check that Y-distance is not
                bcs arsgm_attackdone            ;big (in blocks)
                jsr getactorxdist
                cmp #$01                        ;Check that X-distance is big
                bcc arsgm_attackdone            ;enough
                lda #$00                        ;Aim straight
                ldy #BLT_SHOTGUN
                jsr actorshoot
                jmp enemybrake
arsgm_attackdone:
                lda actd,x
                bmi arsgm_left
arsgm_right:    lda #1
                ldy #12
                bne arsgm_anim
arsgm_left:     lda #-1
                ldy #-12
arsgm_anim:     jmp enemyanim

;Ŀ
;UZIMAN move routine                                                          
;

ar_soldier1:
ar_uziman:      lda actbits,x
                and #AB_JUMP
                beq aruzim_onground
                jmp enemyjump
aruzim_onground: lda actattkd,x
                beq aruzim_attackok
                dec actattkd,x
                jmp enemybrake2
aruzim_attackok:lda actattk,x
                beq aruzim_newattack
                dec actattk,x
                jmp aruzim_nextbullet
aruzim_newattack:
                jsr random                      ;Random decision for attack
                cmp #UZIMANATTKPR
                bcs aruzim_attackdone
                jsr reverseifneeded
                ldy #ACTI_PLAYER
                jsr getactorxdist
                cmp #$01                        ;Check that X-distance is big
                bcc aruzim_attackdone           ;enough
                ldy #$07
                lda actyh+ACTI_PLAYER
                sec
                sbc actyh,x
                beq aruzim_shootstraight
                bpl aruzim_shootbelow
                cmp #$ff
                bcs aruzim_shootstraight
aruzim_shootabove:
                cmp #$fd
                bcc aruzim_attackdone
                ldy #$08
                bne aruzim_shootstraight
aruzim_shootbelow:
                cmp #$04
                bcs aruzim_attackdone
                ldy #$09
aruzim_shootstraight:
                tya
                sta actf,x
                lda #$03                        ;Fire 3 shots
                sta actattk,x
aruzim_nextbullet:
                lda actf,x
                sec
                sbc #$07
                ldy #BLT_SMG
                jsr actorshoot
                jmp enemybrake2
aruzim_attackdone:
                lda actd,x
                bmi aruzim_left
aruzim_right:   lda #2
                ldy #14
                bne aruzim_anim
aruzim_left:    lda #-2
                ldy #-14
aruzim_anim:    jmp enemyanim

;Ŀ
;GANGLEADER move routine                                                      
;

ar_gangleader:  inc bossfight
                lda actbits,x
                and #AB_JUMP
                beq argldr_onground
                jmp enemyjump
argldr_onground:lda actattkd,x
                beq argldr_attackok
                dec actattkd,x
                jmp enemybrake2
argldr_attackok:lda actattk,x
                beq argldr_newattack
                dec actattk,x
                jmp argldr_nextbullet
argldr_newattack:
                ldy #ACTI_PLAYER
                jsr getactorydist
                cmp #$01                        ;At the same level?
                bcc argldr_close
                jsr random
                cmp #GANGLEADERATTKPR
                bcs argldr_attackdone
                jsr reverseifneeded             ;Turn at certain probability
                jmp argldr_attackdone
argldr_close:   jsr getactorxdist
                cmp #$01                        ;Check that X-distance is big
                bcc argldr_attackdone           ;enough
                jsr reverseifneeded             ;If at same level, turn
                bcs argldr_attackdone           ;always
                jsr random                      ;Random decision for attack
                cmp #$02
                bcc argldr_throwgrenade
                cmp #GANGLEADERATTKPR
                bcs argldr_attackdone
                lda #7
                sta actf,x
                lda #3                          ;Fire 3 flames
                sta actattk,x
argldr_nextbullet:
                ldy #BLT_FLAME
argldr_attackcommon:
                lda #$00
                jsr actorshoot
                jmp enemybrake2
argldr_throwgrenade:
                lda #8
                sta actf,x
                ldy #BLT_GRENADE
                bne argldr_attackcommon
argldr_attackdone:
                lda actd,x
                bmi argldr_left
argldr_right:   lda #2
                ldy #18
                bne argldr_anim
argldr_left:    lda #-2
                ldy #-18
argldr_anim:    jmp enemyanim

;Ŀ
;GRENADEMAN move routine                                                      
;

ar_grenademan:  lda actbits,x
                and #AB_JUMP
                beq argrman_onground
                jmp enemyjump
argrman_onground:
                lda actattkd,x
                beq argrman_attackok
                dec actattkd,x
                jmp enemybrake
argrman_attackok:
                jsr random                      ;Random decision for attack
                cmp #GRENADEMANATTKPR
                bcs argrman_attackdone
                ldy #ACTI_PLAYER
                jsr faceactor
                eor actd,x
                and #$80
                bne argrman_attackdone          ;If not facing player, don't
                lda #$00                        ;attack
                ldy #BLT_GRENADE
                jsr actorshoot
                jmp enemybrake
argrman_attackdone:
                lda actd,x
                bmi argrman_left
argrman_right:  lda #2
                ldy #11
                bne argrman_anim
argrman_left:   lda #-2
                ldy #-11
argrman_anim:   jmp enemyanim

;Ŀ
;AIRPLANE move routine                                                        
;

ar_airplane:    lda actf,x
                eor #$01
                sta actf,x
                lda actd,x
                bmi arap_left
                lda #3
                ldy #28
                bne arap_accxdone
arap_left:      lda #-3
                ldy #-28
arap_accxdone:  jsr accactorx
                jsr random
                cmp #AIRPLANETURNPR
                bcs arap_noturn
                lda actattk,x
                eor #$01
                sta actattk,x
arap_noturn:    lda actattk,x
                bne arap_up
                lda #1
                ldy #12
                bne arap_accydone
arap_up:        lda #-1
                ldy #-12
arap_accydone:  jsr accactory
                jsr random
                cmp #AIRPLANEATTKPR
                bcs enemyfly_common
                lda #$02
                ldy #BLT_MOLOTOV
                jsr actorshoot
enemyfly_common:jsr checkjumpobst
                bcc enemyfly_noxobst
                lda #$00
                sta actsx,x
                jsr reverseactor
enemyfly_noxobst:
                lda #-1
                ldy actsy,x
                beq enemyfly_noymove
                bmi enemyfly_up
enemyfly_down:  lda #1
enemyfly_up:    jsr getcharposinfooffset
                and #CI_OBSTACLE
                beq enemyfly_noyobst
enemyfly_yobst: lda #$00
                sta actsy,x
enemyfly_noymove:
                rts
enemyfly_noyobst:
                jmp moveactory

;Ŀ
;MUTANTPIG move routine                                                       
;

ar_mutantpig:   lda actbits,x
                and #AB_JUMP
                beq armtpig_onground
                lda actd,x
                bmi armtpig_left
armtpig_right:  lda #3
                ldy #16
                bne armtpig_accdone
armtpig_left:   lda #-3
                ldy #-16
armtpig_accdone:jsr accactorx
                lda #DMG_MUTANTPIG
                jsr enemyjumpdamage
                jmp enemyjump
armtpig_onground:
                lda #$00
                sta actsx,x
                inc actfd,x
                lda actfd,x
                and #$08
                lsr
                lsr
                lsr
                sta actf,x
                jsr random
                cmp #PIGJUMPPR
                bcs armtpig_nojump
armtpig_jump:   lda #$01
                sta actattk,x
                jmp enemystartjump
armtpig_nojump: rts

;Ŀ
;MUTANTRAT move routine                                                       
;

ar_mutantrat:   lda actbits,x
                and #AB_JUMP
                beq armtrat_onground
                lda actd,x
                bmi armtrat_left
armtrat_right:  lda #8
                ldy #20
                bne armtrat_accdone
armtrat_left:   lda #-8
                ldy #-20
armtrat_accdone:jsr accactorx
                lda #DMG_RAT
                jsr enemyjumpdamage
                jmp enemyjump
armtrat_onground:
                jsr random
                cmp #RATJUMPPR
                bcs armtrat_nojump
                ldy #ACTI_PLAYER
                jsr getactorxdist
                cmp #$01                        ;Check that X-distance is
                bcs armtpig_jump                ;enough
armtrat_nojump: cmp #RATMOVEPR
                bcs armtrat_nomove
                lda #-16
                ldy actd,x
                bmi armtrat_spdok
                lda #16
armtrat_spdok:  sta actsx,x
                bne armtrat_doanim
armtrat_nomove: lda #$01
                jsr brakeactorx
                lda actsx,x
                beq armtrat_noanim
armtrat_doanim: inc actfd,x
                lda actfd,x
                and #$08
                lsr
                lsr
                lsr
                sta actf,x
armtrat_noanim: jmp enemymove

enemyjumpdamage:ldy actattk,x                       ;Only one damage per jump
                beq ejd_nodmg
                jsr playerenemycoll_onetime
                bcs ejd_nodmg
                lda #$00
                sta actattk,x
ejd_nodmg:      rts

;Ŀ
;SOLDIER 2 move routine                                                       
;

ar_soldier2:    lda actbits,x
                and #AB_JUMP
                beq arsld2_onground
                jmp enemyjump
arsld2_onground:lda actattkd,x
                beq arsld2_attackok
                dec actattkd,x
                jmp enemybrake
arsld2_attackok:lda actattk,x
                beq arsld2_newattack
                dec actattk,x
                jmp arsld2_nextbullet
arsld2_newattack:
                jsr random                      ;Random decision for attack
                cmp #SOLDIER2ATTKPR
                bcs arsld2_attackdone
                ldy #ACTI_PLAYER
                jsr getactorydist
                cmp #$01                        ;At the same level?
                bcs arsld2_attackdone
                jsr getactorxdist
                cmp #$01                        ;Check that X-distance is big
                bcc arsld2_attackdone           ;enough
                jsr reverseifneeded             ;If at same level, turn
                lda #3                          ;Fire 3 flames
                sta actattk,x
arsld2_nextbullet:
                ldy #BLT_FLAME
                lda #$00
                jsr actorshoot
                jmp enemybrake
arsld2_attackdone:
                lda actd,x
                bmi arsld2_left
arsld2_right:   lda #2
                ldy #13
                bne arsld2_anim
arsld2_left:    lda #-2
                ldy #-13
arsld2_anim:    jmp enemyanim

;Ŀ
;DOG move routine                                                             
;

ar_dog:         lda actbits,x
                and #AB_JUMP
                beq ardog_onground
                lda #DMG_DOG
                jsr enemyjumpdamage
                lda #-17
                ldy actd,x
                bmi ardog_jumpleft
                lda #17
ardog_jumpleft: sta actsx,x
                jmp enemyjump
ardog_onground: ldy #ACTI_PLAYER
                jsr getactorydist
                cmp #$01                        ;At the same level?
                bcs ardog_attackdone
ardog_close:    jsr getactorxdist
                cmp #$01                        ;Check that X-distance is big
                bcc ardog_attackdone            ;enough
                jsr reverseifneeded             ;If at same level, turn
                bcs ardog_attackdone            ;always
                jsr getactorxdist
                cmp #$02
                bcs ardog_attackdone
                jsr random
                cmp #DOGATTKPR
                bcs ardog_attackdone
                jmp armtpig_jump
ardog_attackdone:
                lda actd,x
                bmi ardog_left
ardog_right:    lda #3
                ldy #17
                bne ardog_anim
ardog_left:     lda #-3
                ldy #-17
ardog_anim:     jsr accactorx
                lda actsx,x
                bpl ardog_spdpos
                clc
                eor #$ff
                adc #$01
ardog_spdpos:   asl
                adc #$20
                adc actfd,x
                sta actfd,x
                bcc ardog_animdone
                lda actf,x
                adc #$00                        ;Carry = 1, add one less
                and #$03
                sta actf,x
ardog_animdone: jmp enemymove

;Ŀ
;HAWK move routine                                                            
;

ar_hawk:        lda actattk,x                       ;Do damage only if gliding
                bne arhawk_nodmg                    ;downwards
                lda #DMG_HAWK
                jsr playerenemycoll_onetime
                bcs arhawk_nodmg
                bcc arhawk_turn
arhawk_nodmg:   lda actd,x
                bmi arhawk_left
                lda #2
                ldy #16
                bne arhawk_accxdone
arhawk_left:    lda #-2
                ldy #-16
arhawk_accxdone:jsr accactorx
                jsr random
                cmp #HAWKTURNPR
                bcs arhawk_noturn
arhawk_turn:    lda actattk,x
                eor #$01
                sta actattk,x
arhawk_noturn:  lda actattk,x
                bne arhawk_up
                lda #1
                ldy #10
                bne arhawk_accydone
arhawk_up:      inc actfd,x
                lda actfd,x
                lsr
                lsr
                lsr
                and #$03
                sta actf,x
                lda #-1
                ldy #-10
arhawk_accydone:jsr accactory
                jmp enemyfly_common

;Ŀ
;TOWERGUNNER move routine                                                     
;

ar_towergunner: lda actattkd,x
                beq artwrg_attackok
                dec actattkd,x
artwrg_attackdone:
                rts
artwrg_attackok:lda actattk,x
                beq artwrg_newattack
                lda #$02
                ldy #BLT_SMG
                jsr actorshoot
                dec actattk,x
                bne artwrg_nodelay              ;If it's the last bullet, set
                lda #$40                        ;a delay
                sta actattkd,x
artwrg_nodelay: rts
artwrg_newattack:
                jsr reverseifneeded
                ldy #ACTI_PLAYER
                jsr getactorxdist
                cmp #$02                        ;Check that X-distance is big
                bcc artwrg_attackdone           ;enough
                cmp #$06
                bcs artwrg_attackdone
                lda #$03                        ;Fire 3 shots
                sta actattk,x
                rts

;Ŀ
;ENEMYJETBIKE move routine                                                    
;

ar_enemyjetbike:lda actattkd,x
                beq arejb_attackok
                dec actattkd,x
                bne arejb_attackdone
arejb_attackok: lda prevbossfight
                bne arejb_left
                jsr random
                cmp #JETBIKEATTKPR
                bcs arejb_attackdone
                jsr reverseifneeded
arejb_nextbullet:
                lda #$00
                ldy #BLT_SMG
                jsr actorshoot
arejb_attackdone:
                lda actd,x
                bmi arejb_left
                lda #3
                ldy #28
                bne arejb_accxdone
arejb_left:     lda #-3
                ldy #-28
arejb_accxdone: jsr accactorx
                jsr random
                cmp #AIRPLANETURNPR
                bcs arejb_noturn
                lda actattk,x
                eor #$01
                sta actattk,x
arejb_noturn:   lda actyh,x
                cmp #$04
                bcc arejb_nottoolow
                lda #$01
                sta actattk,x
arejb_nottoolow:lda actattk,x
                bne arejb_up
                lda #1
                ldy #12
                bne arejb_accydone
arejb_up:       lda #-1
                ldy #-12
arejb_accydone: jsr accactory
arejb_common:   jsr arejb_frame
                jsr moveactorx
                jmp moveactory

arejb_frame:    lda #$01
                ldy actsx,x
                bmi arejb_fneg
                cpy #1*8
                bcc arejb_fdone
                lda #$00
arejb_fdone:    sta actf,x
                rts
arejb_fneg:     cpy #-1*8+1
                bcs arejb_fdone
                lda #$02
                bne arejb_fdone

ar_helicopter:  inc bossfight
                lda actattkd,x
                beq arhlcpt_attackok
                dec actattkd,x
                bne arhlcpt_attackdone
arhlcpt_attackok:
                lda actsy,x
                beq arhlcpt_newattack
                dec actsy,x
                jmp arhlcpt_nextbullet
arhlcpt_newattack:
                jsr random
                cmp #HELICOPTERMISSPR
                bcs arhlcpt_nomissile
                lda #$00
                ldy #BLT_MISSILE
                jsr actorshoot
                jmp arhlcpt_attackdone
arhlcpt_nomissile:
                cmp #HELICOPTERATTKPR
                bcs arhlcpt_attackdone
                lda #$03
                sta actsy,x
arhlcpt_nextbullet:
                lda #$00
                ldy #BLT_SMG
                jsr actorshoot
arhlcpt_attackdone:
                lda actf,x
                eor #$01
                sta actf,x
                lda actfd,x
                beq arhlcpt_nextstep
                dec actfd,x
arhlcpt_sx:     lda #$00
                jsr moveactorxdirect
arhlcpt_sy:     lda #$00
                jmp moveactorydirect
arhlcpt_nextstep:
                ldy actattk,x
arhlcpt_again:  lda arhlcpt_movetbl,y
                bne arhlcpt_nojump
                lda arhlcpt_movetbl+1,y
                tay
                bne arhlcpt_again
arhlcpt_nojump: sta actfd,x
                lda arhlcpt_movetbl+1,y
                sta arhlcpt_sx+1
                lda arhlcpt_movetbl+2,y
                sta arhlcpt_sy+1
                tya
                clc
                adc #$03
                sta actattk,x
                rts

;Ŀ
;GUARD 1 move routine                                                         
;

ar_guard1:      lda actattkd,x
                beq arguard1_attackok
                dec actattkd,x
                jmp enemybrake
arguard1_attackok:lda actattk,x
                beq arguard1_newattack
                dec actattk,x
                jmp arguard1_nextbullet
arguard1_newattack:
                jsr random                      ;Random decision for attack
                cmp #$02
                bcc arguard1_throwgrenade
                cmp #GUARD1ATTKPR
                bcs arguard1_attackdone
                jsr reverseifneeded
                ldy #ACTI_PLAYER
                jsr getactorxdist
                cmp #$01                        ;Check that X-distance is big
                bcc arguard1_attackdone         ;enough
                jsr getactorydist
                cmp #$01
                bcs arguard1_attackdone
                lda #$02                        ;Fire 2 shots
                sta actattk,x
arguard1_nextbullet:
                ldy #BLT_LASER
arguard1_attackcommon:
                lda #$00
                jsr actorshoot
                jmp enemybrake
arguard1_throwgrenade:
                jsr reverseifneeded
                ldy #BLT_GRENADE
                bne arguard1_attackcommon
arguard1_attackdone:
                lda actd,x
                bmi arguard1_left
arguard1_right: lda #3
                ldy #15
                bne arguard1_anim
arguard1_left:  lda #-3
                ldy #-15
arguard1_anim:  jmp enemyanim

;Ŀ
;GUARD 2 move routine                                                         
;

ar_guard2:      lda actbits,x
                and #AB_JUMP
                beq arguard2_onground
                jmp enemyjump
arguard2_onground:lda actattkd,x
                beq arguard2_attackok
                dec actattkd,x
                jmp enemybrake
arguard2_attackok:
                jsr random                      ;Random decision for attack
                cmp #$02
                bcc arguard1_throwgrenade
                cmp #GUARD2ATTKPR
                bcs arguard2_attackdone
                ldy #ACTI_PLAYER
                jsr getactorydist
                cmp #$01                        ;At the same level?
                bcs arguard2_attackdone
                jsr getactorxdist
                cmp #$01                        ;Check that X-distance is big
                bcc arguard2_attackdone         ;enough
                jsr reverseifneeded
                ldy #BLT_GASFIST
                lda #$00
                jsr actorshoot
                jmp enemybrake
arguard2_attackdone:
                lda actd,x
                bmi arguard2_left
arguard2_right: lda #2
                ldy #14
                bne arguard2_anim
arguard2_left:  lda #-2
                ldy #-14
arguard2_anim:  jmp enemyanim

ar_bigrobot:    inc bossfight
                ldy #ACTI_PLAYER                ;Is player trying to get to
                jsr checkcollision              ;the other side?
                bcs arbr_noprevent
                jsr ar_preventplayer
arbr_noprevent: lda actbits,x
                and #AB_JUMP
                beq arbr_onground
                lda #-2*8
                sta actsx,x
                jsr enemyjump
                lda actbits,x
                bne arbr_notlanded
                lda #DMG_ROBOTCRUSH             ;Do massive damage if landed
                jmp playerenemycoll_onetime     ;on player
arbr_nomove:
arbr_notlanded: rts
arbr_onground:  jsr random
                cmp #BIGROBOTJUMPPR             ;Do jump?
                bcs arbr_nojump
                lda actxh,x
                cmp #13
                bcc arbr_nojump
                jmp enemystartjump
arbr_nojump:    inc actfd,x
                lda actfd,x
                and #$07
                bne arbr_nomove
                jsr random
                cmp #BIGROBOTATTKPR
                bcs arbr_nofire
                lda #$80
                sta actd,x
                ldy #BLT_GASFIST
                lda #$00
                jmp actorshoot
arbr_nofire:    cmp #BIGROBOTTURNPR
                bcs arbr_noturn
arbr_turn:      lda actattk,x
                eor #$01
                sta actattk,x
                rts
arbr_noturn:    lda actattk,x
                bne arbr_backwards
arbr_forwards:  lda actxh,x
                cmp #11
                bcc arbr_turn
                inc actf,x
                ldy #-8*8
arbr_movecommon:lda actf,x
                and #$03
                sta actf,x
                tya
                jmp moveactorxdirect
arbr_backwards: lda actxh,x
                cmp #20
                bcs arbr_turn
                dec actf,x
                ldy #8*8
                bne arbr_movecommon

ar_preventplayer:
                ldy #ACTI_PLAYER                ;Is player trying to get to
                jsr faceactor                   ;right side?
                bmi ar_preventok
                lda actsx+ACTI_PLAYER
                bmi ar_preventok
                lda actxl,x                     ;Prevent player :-)
                sta actxl+ACTI_PLAYER
                lda actxh,x                     ;Prevent player :-)
                sta actxh+ACTI_PLAYER
ar_preventok:   rts

;Ŀ
;GENERAL move routine                                                         
;

ar_general:     inc bossfight
                lda actbits,x
                and #AB_JUMP
                beq argeneral_onground
                lda #3*8
                ldy actd,x
                bpl argeneral_jumpok
                lda #-3*8
argeneral_jumpok:
                sta actsx,x
                jmp enemyjump
argeneral_onground:lda actattkd,x
                beq argeneral_attackok
                dec actattkd,x
                jmp enemybrake
argeneral_attackok:
                jsr random                      ;Random decision for attack
                cmp #$04
                bcs argeneral_nojump
                jmp enemystartjump
argeneral_nojump:
                cmp #GENERALATTKPR
                bcs argeneral_attackdone
                ldy #ACTI_PLAYER
                jsr getactorydist
                cmp #$01                        ;At the same level?
                bcs argeneral_attackdone
                jsr getactorxdist
                cmp #$01                        ;Check that X-distance is big
                bcc argeneral_attackdone         ;enough
                jsr reverseifneeded
                ldy #BLT_GASFIST
                lda #$00
                jsr actorshoot
                jmp enemybrake
argeneral_attackdone:
                lda actd,x
                bmi argeneral_left
argeneral_right:lda #2
                ldy #18
                bne argeneral_anim
argeneral_left: lda #-2
                ldy #-18
argeneral_anim: jmp enemyanim

ar_generalout:  inc bossfight
                jmp ar_enemyout

;Ŀ
;BYSTANDER move routine                                                       
;

ar_bystander:   lda actattk,x                   ;Speed & type already
                bne arbyst_speedok              ;randomized?
                jsr random
                and #$03
                clc
                adc actt,x
                sta actt,x
arbyst_randomizespeed:
                jsr random
                and #$07
                clc
                adc #$08
                sta actattk,x
                eor #$ff
                adc #$01
                sta actattkd,x
arbyst_speedok: lda actd,x
                bmi arbyst_left
arbyst_right:   lda #3
                ldy actattk,x
                bne arbyst_move
arbyst_left:    lda #-3
                ldy actattkd,x
arbyst_move:    jmp enemyanim

ar_doctor:      lda actattk,x
                bne arbyst_speedok
                beq arbyst_randomizespeed

;Ŀ
;Common knocked-out enemy routine                                             
;

ar_pilotout:    lda actfd,x
                bne ar_enemyout
                inc actfd,x
                lda #$03                        ;Spawn up to 3 random
                jmp spawnexplosions             ;explosions

ar_enemyout:    lda actf,x                      ;On the ground or flying?
                bne arenmyo_ground
arenmyo_flying: lda #1
                ldy #3*8
                jsr accactory
                lda #$00
                sta temp3
                jsr checkjumpobst               ;Perform X-movement and check
                bcc arenmyo_noobst              ;obstacles
                lda actsx,x                     ;If hit obstacle, reverse &
                tay
                asl
                tya
                ror
                clc
                eor #$ff
                adc #$01
                sta actsx,x
arenmyo_noobst: jsr checklanding2               ;obstacles, also check
                bcs arenmyo_landed              ;"diagonal" landing :-)
                jsr moveactory
                jsr checklanding
                bcc arenmyo_notlanded
arenmyo_landed: inc actf,x
arenmyo_notlanded:
arenmyo_done:   rts
arenmyo_ground: inc actfd,x
                lda actfd,x
                cmp #$60
                bcc arenmyo_noremove
                jmp ract_noorigin
arenmyo_noremove:cmp #$30
                bcc arenmyo_noflash
                lda actf,x                     ;Flash before removing
                eor #$80
                sta actf,x
arenmyo_noflash:rts

ar_motoristout: lda actfd,x
                bne ar_enemyout
                inc actfd,x
                lda #$02                        ;Spawn up to 2 random
spawnexplosions:sta temp2                       ;explosions
                lda #SFX_EXPLOSION
                jsr playsfx
spawnexpl_loop: lda #ACTI_LASTENEMYBLT          ;Use any free actor,
                ldy #ACTI_FIRSTOTHER            ;except player bullets
                jsr getfreeactor
                bcc spawnexpl_done
                lda #ACT_EXPLOSION
                sta actt,y
                jsr random
                and #$7f
                sbc #$40
                jsr math_signadjust
                adc actxl,x
                sta actxl,y
                lda actxh,x
                adc temp1
                sta actxh,y
                jsr random
                and #$7f
                sbc #$40
                jsr math_signadjust
                adc actyl,x
                sta actyl,y
                lda actyh,x
                adc temp1
                sta actyh,y
                dec temp2
                bne spawnexpl_loop
spawnexpl_done: rts

ar_jetbikeout:  jsr flaminglanding
                jmp arejb_accydone

ar_helicopterout:inc bossfight
                lda #$01
                sta helicopterdefeated
                jsr flaminglanding
                jsr accactory
                jsr moveactory
                rts

flaminglanding: jsr random
                cmp #$10
                bcs arjbo_noexpl
                lda #$01
                jsr spawnexplosions
arjbo_noexpl:   lda #1
                ldy #3*8
                rts

ar_bigrobotout: inc actfd,x
                beq ar_broend
                lda actf,x
                eor #$80
                sta actf,x
                jsr random
                cmp #$18
                bcs ar_bronoexplosion
                lda #$01
                jmp spawnexplosions
ar_broend:      lda #$00
                sta actt,x
ar_bronoexplosion:
                rts

;Ŀ
;PLAYERENEMYCOLL                                                              
;                                                                             
;Does damage to player if collided with an enemy                              
;Note! Checks collisions only on every third frame to prevent too much        
;damage (it's still quite much :-))                                           
;                                                                             
;Parameters: X:Enemy actor number                                             
;            A:Damage                                                         
;Returns: C=1 no collision, C=0 collided                                      
;Modifies: A,Y,many temp variables                                            
;

playerenemycoll_onetime:
playerenemycoll:sta plrenmycol_dmg+1
plrenmycol_common:
                ldy #ACTI_PLAYER
                jsr checkcollision
                bcs plrenmycol_nocoll
plrenmycol_dmg: lda #$00
                jsr punish
                clc
plrenmycol_nocoll:
                rts

;Ŀ
;ENEMYREWARD                                                                  
;                                                                             
;Adds score & possibly leaves an item, when an enemy is defeated.             
;                                                                             
;Parameters: X:Actor number                                                   
;Returns: -                                                                   
;Modifies: A,Y,temp1-temp2                                                    
;

er_boss:        tay
                lda bossrewardtbllo-$80,y
                sta er_bossjmp+1
                lda bossrewardtblhi-$80,y
                sta er_bossjmp+2
er_bossjmp:     jmp $0000

enemyreward:    ldy actt,x
                lda enemyscore-ACT_FIRSTENEMY,y
                jsr addscore
                ldy actt,x
                lda enemyitemindex-ACT_FIRSTENEMY,y ;Get itemtable index
                bmi er_boss                     ;Negative = special
                beq er_noitem
er_back:        sta temp2
                jsr random                      ;60% probability
                cmp #$99                        ;to get an item
                bcs er_noitem
                and #$03
                clc
                adc temp2                       ;Add random number (0-3)
                tay
                lda enemyitemtbl-1,y
                beq er_noitem
                sta temp1
                cmp #ITEM_NUNCHAKU+1            ;A melee weapon?
                bcs er_nomeleewpn
                jsr finditem                    ;If player already has it,
                bcs er_noitem                   ;don't give another to avoid
er_nomeleewpn:  lda #ACTI_LASTITEM              ;filling the screen
                ldy #ACTI_FIRSTITEM
                jsr getfreeactor
                bcc er_noitem                   ;Found a free actor?
                lda actxl,x
                sta actxl,y
                lda actxh,x
                sta actxh,y
                lda actyl,x
                sec
                sbc #8*8
                sta actyl,y
                lda actyh,x
                sbc #$00
                sta actyh,y
                lda #ACT_ITEM
                sta actt,y
                lda temp1
                sta actf,y
                lda #-3*8                       ;Item will bounce upwards
                sta actsy,y
                lda #AB_JUMP
                sta actbits,y
er_noitem:      rts

reverseifneeded:ldy #ACTI_PLAYER
                jsr faceactor
                eor actd,x
                and #$80
                beq rin_dirok
                sec
                jmp reverseactor
rin_dirok:      clc
                rts

;Ŀ
;Special boss defeat routines                                                 
;                                                                             
;Parameters: X:Actor number                                                   
;Returns: -                                                                   
;Modifies: A,Y,temp1-temp2                                                    
;

guarddefeated:  stx temp1
                lda #PB_CARDCREATED
                jsr checkplotbit
                bcs gd_gotcard
                lda #PB_CARDCREATED
                jsr setplotbit
                jsr createactor_search
                bcc gd_noplace
                jsr storeactorpos
                lda #ACT_ITEM
                sta lvlactt,y
                lda #ITEM_KEYCARD
                sta lvlactp,y
gd_noplace:     rts
gd_gotcard:     lda #ITEMINDEX_GUARD1
                ldy actt,x
                jmp er_back

gangleaderdefeated:
                lda #PB_GANGLEADER
                jsr setplotbit
                jsr createactor_search
                bcc gld_noplace
                jsr storeactorpos
                lda #ACT_ITEM
                sta lvlactt,y
                lda #ITEM_CTRLROOMKEY
                sta lvlactp,y
gld_noplace:    rts

bigrobotdefeated:
                lda #PB_ROBOTDEFEATED
                jmp setplotbit

generaldefeated:lda #PB_GAMECOMPLETED
                jmp setplotbit
