;ͻ
;Metal Warrior III by Cadaver                                                 
;Project officially started 5/2000, although scroll & sprite routines also    
;partially programmed before that!                                            
;ͼ

                include define.s
                include memory.s

                processor 6502
                org maincodestart

                include raster.s

start:

begintitle:     jsr cleartextscreen
                lda #$00
                sta titlephase
                jsr loadsprites                 ;Load logo sprites
                lda #MUSIC_TITLE
                jsr playtune

backtotitle:    jsr titlescreen
gamemenu:       lda #<gamemenutext
                sta textptrlo
                lda #>gamemenutext
                sta textptrhi
                lda gamemenuchoice
                ldx #$05
                ldy #$05
                jsr menu
                sta gamemenuchoice
                bcs backtotitle
                tax
                beq introduction
                dex
                beq newgame
                dex
                beq continuegame
                dex
                beq gameinstr
                dex
                beq exitgame
                bne backtotitle

introduction:   jsr runcutscene
                jmp begintitle

gameinstr:      jsr showinstr
                jmp gamemenu

exitgame:       lda #<confirmmenutext
                sta textptrlo
                lda #>confirmmenutext
                sta textptrhi
                lda #$01
                ldx #$02
                ldy #$07
                jsr menu
                bcs gamemenu
                bne gamemenu
                sei
                lda #$36
                sta $01
                jmp 64738

continuegame:   jsr enterpassword
                jsr initgame
                jsr loadfrompwd
                bcs continueok
                jsr initpwd                     ;If wrong password, clear it
                jsr initgame
                jmp backtotitle
newgame:        jsr initgame
continueok:     jsr generatepwd
                ldy lastdoornum
                jsr checkdooropen
                ldx lastdoornum
                jmp doorentered

newlocation:    jsr cleartextscreen
                lda loadedlevel
                cmp levelnum
                beq samelevel
                jsr generatepwd
                jsr fademusic_nowait
samelevel:      lda timehour
                jsr atime_clmode
                jsr removeallactors
                jsr loadlevel
                jsr loadteammember
                jsr playleveltune
                jsr centerplayer
                jsr addallactors
                jsr drawscreen
backtogame:     jsr initteammember

mainloop:       jsr getcontrols
                jsr updatepanel
                jsr checkgamekeys
                lda pausemode
                bne skipmove
                jsr charanim
                jsr selectitem
                jsr addsomeactors
                jsr processtm
                jsr moveactors
                jsr processtmafter
                jsr checkscroll
skipmove:       jsr scrolllogic
                jsr drawactors
                jsr sortsprites
                jsr erasechars
                jsr scrollwork
                jsr drawchars
                ldx enterdoornum                ;Entered a door?
                beq nodoorentered
                lda actf+ACTI_PLAYER            ;No delay if not facing away
                cmp #PLRFR_ENTER                ;from player
                bne skipdoordelay
                jsr delay
skipdoordelay:  ldx enterdoornum
                bne doorentered
nodoorentered:  ldx commnum                     ;Communication with an NPC?
                bne communication
                ldx autoremovedoornum           ;Autoremove-system triggered?
                bne checkautoremove
noautoremove:   lda actt+ACTI_PLAYER            ;Teammember out?
                beq selecttmtest
                lda plotbits+1                  ;Game won?
                and #$20
                beq mainloop
                lda bossfight
                bne mainloop                    ;If none of these, continue
                jmp victory                     ;main loop

selecttmtest:   jsr selecttm                    ;"Forced" selection of team-
                bcc endgame                     ;member
                jmp mainloop                    ;Game continues
endgame:        jsr enterhiscore                ;Game ends when no teammembers
                lda #$02
                sta gamemenuchoice
                jsr showpassword
                jmp begintitle                  ;left
checkautoremove:lda timehour
                cmp autoremovetime
                bne noautoremove
                lda #<autoremovetext
                ldx #>autoremovetext
                ldy #100
                jsr newmessage
                ldx autoremovedoornum
                lda doord,x
                tax
                lda #$00
                sta autoremovedoornum
doorentered:    cpx #DOOR_FINAL                 ;"Special" doors checked here
                beq finaldoor
                cpx #DOOR_COMPUTER1
                beq computer1
                cpx #DOOR_FLIGHTLEVEL
                beq flightlevel
                cpx #DOOR_GENERATOR
                beq switchgenerator
                cpx #DOOR_COMPUTER2
                beq computer2
                cpx #DOOR_GYM
                beq entergym
normaldoor:     jsr movetodoor
                jmp newlocation
communication:  jsr delay
                jsr commroutine
                jmp backtogame

entergym:       jsr gymroutine
                jmp backtogame

switchgenerator:lda #PB_GENERATOR
                jsr toggleplotbit
                jmp backtogame

finaldoor:      stx lastdoornum
                lda #<finaldoorscript
                ldx #>finaldoorscript
                jsr runscript
                ldx #DOOR_FINAL
                bne normaldoor

computer1:      lda #<computer1script
                ldx #>computer1script
                jsr runscript
                lda loadedlevel                 ;Has the cutscene fucked up
                cmp #$ff                        ;all leveldata?
                bne comp_backtogame
                ldx #DOOR_ULTRASHREDCOMPUTER
                bne normaldoor
comp_backtogame:jmp backtogame

computer2:      lda #<computer2script
                ldx #>computer2script
                jsr runscript
                jmp backtogame

victory:        jsr fademusic
                jsr cleartextscreen
                lda #FIRSTCUTSCENEFILE+$07      ;Load endtexts
                jsr loadfile
                lda #CUTSCENE_VICTORY
                jsr runcutscene
                jmp endgame

delay:          lda #$08                        ;A little delay
delay2:
delayloop:      pha
                jsr waitandupdate_notoggle
                pla
                sec
                sbc #$01
                bne delayloop
                rts

;Ŀ
;FLIGHTLEVEL                                                                  
;                                                                             
;Special code for the jetbike flight scene                                    
;                                                                             
;Parameters: -                                                                
;Returns: -                                                                   
;Modifies: A,X,Y                                                              
;

flightlevel:    jsr generatepwd
                jsr cleartextscreen
                jsr removeallactors
                lda #CUTSCENE_FLIGHT
                jsr runcutscene
                lda timehour
                jsr atime_clmode
                lda #LEVEL_FLIGHT
                sta levelnum
                jsr loadlevel
                jsr playleveltune
                ldx #$00
                stx mapx
                stx mapy
                stx parallaxcount1
                stx parallaxcount2
                stx parallaxcount3
                stx parallaxcount4
                stx actd+ACTI_PLAYER
                stx actf+ACTI_PLAYER
                stx actfd+ACTI_PLAYER
                stx actattkd+ACTI_PLAYER
                stx actxl+ACTI_PLAYER
                stx actyl+ACTI_PLAYER
                stx actsx+ACTI_PLAYER
                stx actsy+ACTI_PLAYER
                stx roundtrips
                stx helicopterdefeated
                stx blockx
                inx
                stx blocky
                ldx #$04
                stx actxh+ACTI_PLAYER
                dex
                stx actyh+ACTI_PLAYER
                lda #ACT_PLRJETBIKE
                sta actt+ACTI_PLAYER
                lda #MAXPLRHEALTH
                sta acthp+ACTI_PLAYER
                lda #TM_GOAT
                sta teammember
                lda #$10
                sta lvlacty+1
                jsr drawscreen
flightloop:     jsr getcontrols
                jsr updatepanel
                jsr checkgamekeys
                lda pausemode
                bne flightskipmove
                jsr addsomeactors
                jsr moveactors
                jsr bossfightmusic
                jsr advancetime
                lda #$01
                sta scrollsx
flightskipmove: jsr scrolllogic
                jsr drawactors
                jsr sortsprites
                jsr erasechars
                jsr scrollwork
                jsr drawchars
                jsr parallaxeffect
                lda roundtrips
                cmp #$02
                bcc flightnoboss
                lda #$00
                sta lvlactt
                lda #$02
                sta lvlacty+1
flightnoboss:   lda bossfight
                bne flightnovictory
                lda helicopterdefeated
                bne flightvictory
flightnovictory:lda actt+ACTI_PLAYER
                bne flightloop
                jmp endgame
flightvictory:  lda #<flightendscript
                ldx #>flightendscript
                jsr runscript
                ldx #138
                jmp doorentered

;Ŀ
;CHECKGAMEKEYS                                                                
;                                                                             
;Checks pause on/off and quitting of game, as well as sound/music toggling    
;and teammember selecting.                                                    
;                                                                             
;Parameters: -                                                                
;Returns: -                                                                   
;Modifies: A,X,Y                                                              
;

checkgamekeys:  ldx keytype
                lda pausemode
                beq chkp_noquit
                cpx #KEY_Q
                bne chkp_noquit
                pla
                pla
                jsr fademusic
                jmp endgame
chkp_noquit:    cpx #KEY_RUNSTOP
                bne chkp_norunstop
chkp_runstop:   eor #$01
                sta pausemode
                beq chkp_pauseoff
chkp_pauseon:   lda #<pauseontext
                ldx #>pauseontext
chkp_pausecommon:ldy #50
                jmp newmessage
chkp_pauseoff:  lda #<pauseofftext
                ldx #>pauseofftext
                bne chkp_pausecommon

chkp_norunstop: cpx #KEY_CR
                bne togglemusic
                lda actt+ACTI_PLAYER
                cmp #ACT_PLRDUCK
                beq chkp_tmok
                lda actt+ACTI_PLAYER
                cmp #ACT_PLRRUN
                bne togglemusic
                lda actbits+ACTI_PLAYER
                and #AB_JUMP
                bne togglemusic
chkp_tmok:      lda pausemode
                bne togglemusic
                pla
                pla
                jmp selecttmtest

togglemusic:    ldx keytype
                cpx #KEY_M
                bne tglm_nomusic
                lda musicmode
                eor #$01
                sta musicmode
                bne tglm_musicon
tglm_musicoff:  lda #MUSIC_SILENCE
                jsr playtune_common
                lda #<musicofftext
                ldx #>musicofftext
                bne tglm_musiccommon
tglm_musicon:   lda tunenumber
                jsr playtune_common
                lda #<musicontext
                ldx #>musicontext
tglm_musiccommon:
                ldy #50
                jmp newmessage
tglm_nomusic:   cpx #KEY_S
                bne tglm_nosfx
                ldy #50
                lda sfxmode
                eor #$01
                sta sfxmode
                beq tglm_sfxoff
                lda #<sfxontext
                ldx #>sfxontext
                bne tglm_musiccommon
tglm_sfxoff:    lda #<sfxofftext
                ldx #>sfxofftext
                bne tglm_musiccommon
tglm_nosfx:     rts

;Ŀ
;PLAYTUNE                                                                     
;                                                                             
;Plays a tune if music is active, else plays silence.                         
;                                                                             
;Parameters: A:Tune number (0=silence, 1+ different tunes)                    
;Returns: -                                                                   
;Modifies: A,X,Y,many temp variables if music has to be loaded                
;

playtune:       sta tunenumber
playtune_common:pha
                tax
                lda musicbanktbl,x
                bmi playtune_skipload           ;For memory-resident tunes
                cmp loadedmusicbank
                beq playtune_skipload
                sta loadedmusicbank
                lda #$01                        ;Init silence tune when
                sta music+1                     ;loading
                jsr cleartextscreen
                lda loadedmusicbank
                clc
                adc #FIRSTMUSICFILE
                jsr loadfile
playtune_skipload:
                pla
                tax
                lda musicindextbl,x
                ldy musicmode
                bne playtune_nosilence
                lda #$01
playtune_nosilence:
                sta music+1
                rts

;Ŀ
;PLAYSFX                                                                      
;                                                                             
;Plays a sound effect if effects are active.                                  
;                                                                             
;Parameters: A:Sound effect number*$04                                        
;Returns: -                                                                   
;Modifies: A                                                                  
;

playsfx:        pha
                lda music+1                     ;If a music initialization
                bmi playsfx_anotherfx
                bne playsfx_skip                ;is going on, don't disturb
                lda sfxmode                     ;it
                beq playsfx_skip
playsfx_anotherfx:
                pla
                cmp music+1
                bcc playsfx_lowerpriority
                sta music+1
playsfx_lowerpriority:
                rts
playsfx_skip:   pla
fm_done:        rts

;Ŀ
;FADEMUSIC                                                                    
;                                                                             
;Will fade the music if music is active, and wait until fade is complete.     
;                                                                             
;Parameters: -                                                                
;Returns: -                                                                   
;Modifies: A                                                                  
;

fademusic:      ldy #$01
fademusic_common:
                lda musicmode
                beq fm_done
                lda tunenumber
                beq fm_done
                lda #MUSIC_SILENCE
                sta tunenumber
                lda #$60
                sta music+1
                tya
                beq fm_done
                lda #$48
                jmp delay2

fademusic_nowait:
                ldy #$00
                beq fademusic_common

                include screen.s
                include sprite.s
                include control.s
                include math.s
                include actor.s
                include enemy.s
                include weapon.s
                include player.s
                include items.s
                include level.s
                include comm.s
                include title.s
                include data.s

mw3end:

                include music.s
                include init.s

