;ͻ
;Metal Warrior III by Cadaver: Player move routines                           
;Started in 6/2000!                                                           
;ͼ

PLRFR_STAND     = 0
PLRFR_RUN       = 1
PLRFR_JUMP      = 7
PLRFR_ENTER     = 8

;Ŀ
;INITGAME                                                                     
;                                                                             
;Initializes game variables and player actor                                  
;                                                                             
;Parameters: -                                                                
;Returns: -                                                                   
;Modifies: A,Y                                                                
;

initgame:       jsr initactors
                jsr initinventory
                lda #$00
                ldx #$03
igloop1:        sta score,x                     ;Clear score
                dex
                bpl igloop1
                sta pausemode                   ;Reset pause
                lda #$80
                sta actd+ACTI_PLAYER            ;Face player left :-)
                ldx #MAXTM*3-1
igloop2:        lda tminitagility,x             ;Copy initial teammember
                sta tmagility,x                 ;attributes
                dex
                bpl igloop2
                ldx #MAXTM-1
igloop3:        lda #STAT_NOTJOINED             ;Clear status, experience,
                sta tmstat,x                    ;healing counter
                sta tmhealcntlo,x
                sta tmhealcnthi,x
                sta tmhealspd,x
                sta tmexpcount,x
                sta tmexplo,x
                sta tmexphi,x
                dex
                bpl igloop3
                lda #ITEM_PISTOL                ;Pistol and 20 shots at
                sta invtype+1                   ;game beginning
                lda #$20
                sta invammolo+1
                lda #ITEM_CREDITS               ;50 credits at game
                sta invtype+2                   ;beginning
                lda #$50
                sta invammolo+2

                ldx #TM_GOAT                    ;GOAT begins the game
                stx teammember
                lda #STAT_ACTIVE
                sta tmstat,x
                jsr itemcapacity                ;Calculate initial
                                                ;carrying capacity
                lda #GAMEBEGINHOUR              ;Init game clock
                jsr inittime
                lda #$00                        ;Start on Monday
                sta daynumber

                ldx #$ff                        ;Force loading of the level
                stx loadedlevel
                inx
                stx autoremovedoornum           ;Reset the autoremove-system
                stx plotbits+1                  ;Clear plot bits
                stx lastdoornum                 ;Start location

                inx
                stx plotbits                    ;Set plot bit 1: GOAT's cabin
                                                ;in flames
team_fullhp:    ldx #MAXTM-1
team_fhploop:   lda #MAXPLRHEALTH               ;Maximum health to all team-
                sta tmhp,x                      ;members
                dex
                bpl team_fhploop
                sta acthp+ACTI_PLAYER
                rts

initteammember: lda #$00                        ;Init player actor
                sta actf+ACTI_PLAYER
                sta actbits+ACTI_PLAYER
                sta actsx+ACTI_PLAYER
                sta actsy+ACTI_PLAYER
                sta actattk+ACTI_PLAYER
                sta actattkd+ACTI_PLAYER
                sta enterdoornum                ;Reset NPC-communication and
                sta commnum                     ;door entering
                lda #ACT_PLRRUN
                sta actt+ACTI_PLAYER
                ldx teammember
                ldy tmagility,x                 ;Copy agility to player move
                tya                             ;code
                sta arplrrun_posacc+1
                clc
                eor #$ff
                adc #$01
                sta arplrrun_negacc+1
                lda jumpspdtbl-1,y
                sta arplrrun_jumpspeed+1
                ldy tmstrength,x                ;Copy strength to damage bonus
                sty atdmgbonus+ACT_PLRRUN-1     ;table
                sty atdmgbonus+ACT_PLRDUCK-1
                lda climbspdtbl-1,y
                sta arplrclimb_speed+1
                lda tmvitality,x                ;Copy vitality to armor bonus
                clc                             ;table
                adc #$01
                sta atarmor+ACT_PLRRUN-1
                sta atarmor+ACT_PLRDUCK-1
                sta atarmor+ACT_PLRCLIMB-1
                jmp preventattack

;Ŀ
;GIVEEXP                                                                      
;                                                                             
;Increases experience points of current teammember.                           
;                                                                             
;Parameters: A:How much experience given (as 256ths of one exp.point)         
;Returns: -                                                                   
;Modifies: A                                                                  
;

giveexp:        stx giveexp_restx+1
                ldx teammember
                jsr giveexp_common
giveexp_restx:  ldx #$00
                rts
giveexp_common: clc
                adc tmexpcount,x
                sta tmexpcount,x
                bcc giveexp_done
                sed
                lda tmexplo,x
                adc #$00                        ;Add $01 (carry=1!)
                sta tmexplo,x
                cld
                bcc giveexp_noinchi
                inc tmexphi,x
giveexp_noinchi:lda tmexphi,x
                cmp #$03                        ;Maximum experience: 300
                bcc giveexp_done                ;points
                lda #$03
                sta tmexphi,x
                lda #$00
                sta tmexplo,x
giveexp_done:   rts

;Ŀ
;PROCESSTM                                                                    
;                                                                             
;Processes teammember related things (mainly healing)                         
;Also calls ADVANCETIME.                                                      
;It is important to call this before MOVEACTORS so that correct teammember    
;stats are used.                                                              
;                                                                             
;Parameters: -                                                                
;Returns: -                                                                   
;Modifies: A,X,Y                                                              
;

processtm:      ldx #MAXTM-1
prtm_loop:      lda tmstat,x                    ;Joined the team?
                beq prtm_next
                lda tmhp,x                      ;Need healing?
                cmp #MAXPLRHEALTH
                bcs prtm_maxhp
                lda tmvitality,x                ;Normal healing speed
                ldy tmhealspd,x                 ;Medikit used?
                bne prtm_fastheal
prtm_normalheal:clc
                adc tmhealcntlo,x
                sta tmhealcntlo,x
                bcc prtm_next
prtm_fastheal:  inc tmhealcnthi,x
                lda tmhealcnthi,x
                cmp #$08
                bcc prtm_next
                lda #$00
                sta tmhealcnthi,x
                tya
                beq prtm_normalheal2
                dec tmhealspd,x                 ;Decrease speed-healing counter
prtm_normalheal2:                               ;after one hitpoint has been
                inc tmhp,x                      ;restored
                lda #32                         ;Give experience for each
                jsr giveexp_common              ;point healed
                ldy tmhp,x
                cpy #MAXPLRHEALTH/2             ;Teammember returned to active
                bcc prtm_next                   ;status after half of hitpoints
                lda #STAT_ACTIVE                ;have been restored
                sta tmstat,x
                bne prtm_next
prtm_maxhp:     lda #$00                        ;Reset speed-healing counter
                sta tmhealspd,x
                lda #STAT_ACTIVE
                sta tmstat,x
prtm_next:      dex
                bpl prtm_loop
                ldx teammember
                lda tmhp,x                      ;Copy hitpoints
                sta acthp+ACTI_PLAYER

;Ŀ
;ADVANCETIME                                                                  
;                                                                             
;Makes game clock go forward. Called on each frame (50/sec)                   
;                                                                             
;Parameters: -                                                                
;Returns: -                                                                   
;Modifies: A,X                                                                
;

advancetime:    inc timeframe
                lda timeframe
                cmp #50
                bcs atime_nextmin
                rts
atime_nextmin:  lda #$00
                sta timeframe
                sed
                lda timemin
                adc #$00                        ;Carry=1
                cmp #$60
                bcs atime_nexthour
                sta timemin
                cld
                rts
atime_nexthour: lda #$00
                sta timemin
                lda timehour
                adc #$00                        ;Carry=1
                cld
                cmp #$24
                bcc atime_clmode
                lda daynumber
                adc #$00
                cmp #$07
                bcc atime_weeknotover
                lda #$00
atime_weeknotover:
                sta daynumber
                lda #$00
atime_clmode:   sta timehour
                lsr
                tax
                lda timecltbl,x
                sta colormode
                rts

;Ŀ
;PROCESSTMAFTER                                                               
;                                                                             
;Second part of teammember processing (saves changes to teammember stats.)    
;Called after MOVEACTORS.                                                     
;Processes also some plot-related special events.                             
;                                                                             
;Parameters: -                                                                
;Returns: -                                                                   
;Modifies: A,X,Y                                                              
;

processtmafter: ldx teammember
                lda acthp+ACTI_PLAYER
                sta tmhp,x
                bne prtmafter_notout                    ;Teammember out?
                lda #STAT_OUT
                sta tmstat,x
prtmafter_notout:
                lda timeframe                           ;Special event 1:
                ora timemin                             ;Flames in Goat's
                bne prtmafter_noevent1                  ;cabin extinguish
                lda timehour                            ;after one hour
                cmp #GAMEBEGINHOUR+1
                bne prtmafter_noevent1
                lda #PB_FLAMES
                jsr clearplotbit
prtmafter_noevent1:
                lda tmstat+TM_IAN                       ;If already visited in
                bne prtmafter_noevent2                  ;the base, no truck
                lda levelnum                            ;Special event 2:
                cmp #LEVEL_MOUNTAINS                    ;the truck
                bne prtmafter_noevent2
                lda actxh+ACTI_PLAYER
                cmp #165
                bcc prtmafter_noevent2
                lda actyh+ACTI_PLAYER
                cmp #9
                bcs prtmafter_noevent2
                lda timeframe
                ora timemin
                bne prtmafter_noevent2
                lda timehour
                cmp #$08
                beq prtmafter_event2
                cmp #$12
                beq prtmafter_event2
                cmp #$16
                bne prtmafter_noevent2
prtmafter_event2:
                lda #ACTI_LASTOTHER
                ldy #ACTI_FIRSTOTHER
                jsr getfreeactor
                bcc prtmafter_noevent2
                lda #ACT_TRUCK
                sta actt,y
                lda charsubxh
                sta actxh,y
                lda #8
                sta actyh,y
                lda #$00
                sta actxl,y
                sta actyl,y
                lda #<trucktext
                ldx #>trucktext
                ldy #100
                jsr newmessage
prtmafter_noevent2:
bossfightmusic: lda bossfight                   ;Has bossfight state changed?
                tay
                cmp prevbossfight
                beq prtmafter_nobossfight
                tya                             ;Just to update flags
                sta prevbossfight
                beq prtmafter_endbossfight
prtmafter_startbossfight:
                lda #MUSIC_BOSSFIGHT
                jmp playtune
prtmafter_endbossfight:
                jmp playleveltune
prtmafter_nobossfight:
                rts

;Ŀ
;AR_PLAYERJETBIKE                                                             
;                                                                             
;Player move routine                                                          
;                                                                             
;Parameters: X:Actor number                                                   
;Returns: -                                                                   
;Modifies: A,Y                                                                
;

ar_playerjetbike:
                lda acthp,x
                bne ar_plrjbalive
                jsr flaminglanding
                jsr accactory
                jsr moveactory
                lda actyh,x
                cmp #$10
                bcc ar_plrjbnotout
                lda #$00
                sta actt,x
ar_plrjbnotout: rts
ar_plrjbalive:  inc actfd,x
                lda actfd,x
                lsr
                and #$01
                sta actf,x
                lda joystick
                and #JOY_RIGHT
                beq arplrjb_notright
                lda #3
                ldy #24
                bne arplrjb_xaccdone
arplrjb_notright:
                lda joystick
                and #JOY_LEFT
                beq arplrjb_notleft
                lda #-3
                ldy #-24
                bne arplrjb_xaccdone
arplrjb_notleft:lda #1
                jsr brakeactorx
                jmp arplrjb_xctrldone
arplrjb_xaccdone:
                jsr accactorx
arplrjb_xctrldone:
                lda joystick
                and #JOY_DOWN
                beq arplrjb_notdown
                lda #3
                ldy #16
                bne arplrjb_yaccdone
arplrjb_notdown:
                lda joystick
                and #JOY_UP
                beq arplrjb_notup
                lda #-3
                ldy #-16
                bne arplrjb_yaccdone
arplrjb_notup:  lda #1
                jsr brakeactory
                jmp arplrjb_yctrldone
arplrjb_yaccdone:
                jsr accactory
arplrjb_yctrldone:
                jsr moveactorx
                jsr moveactory
                lda actxh,x
                cmp #$02
                bcs arplrjb_nolimit1
                lda #$02
                sta actxh,x
                lda #$00
                sta actxl,x
                sta actsx,x
arplrjb_nolimit1:
                lda actxh,x
                cmp #$09
                bcc arplrjb_nolimit2
                lda #$08
                sta actxh,x
                lda #$ff
                sta actxl,x
                lda #$00
                sta actsx,x
arplrjb_nolimit2:
                lda actyh,x
                cmp #$01
                bcs arplrjb_nolimit3
                lda #$01
                sta actyh,x
                lda #$00
                sta actyl,x
                sta actsy,x
arplrjb_nolimit3:
                lda actyh,x
                cmp #$04
                bcc arplrjb_nolimit4
                lda #$03
                sta actyh,x
                lda #$ff
                sta actyl,x
                lda #$00
                sta actsy,x
arplrjb_nolimit4:
                lda actattkd,x
                beq arplrjb_shootok
                dec actattkd,x
                rts
arplrjb_shootok:lda joystick
                and #JOY_FIRE
                beq arplrjb_nofire
                lda #$00                        ;Aim straight
                ldy #BLT_SMG
                jsr actorshoot
arplrjb_nofire: rts

;Ŀ
;AR_PLRRUN                                                                    
;AR_PLRDUCK                                                                   
;AR_PLRCLIMB                                                                  
;                                                                             
;Player move routine                                                          
;                                                                             
;Parameters: X:Actor number                                                   
;Returns: -                                                                   
;Modifies: A,Y                                                                
;

ar_plrrun:      jsr playerattack
                lda actbits,x                   ;Jumping/falling?
                and #AB_JUMP
                beq arplrrun_onground
                lda #PLRFR_JUMP
                sta actf,x
                ldy #1
                lda actsy,x                     ;When going up, jump can
                bpl arplrrun_dogravity          ;be made longer by pressing
                lda joystick                    ;joystick up
                and #JOY_UP
                bne arplrrun_dogravity
                iny
arplrrun_dogravity:
                tya
                ldy #20
                jsr accactory
                lda joystick                    ;Moving right while jumping?
                and #JOY_RIGHT
                beq arplrrun_nojright
                lda #$01
                sta actd,x
arplrrun_maxposspd1:ldy #2*8                    ;Max speed
                jsr slowaccactorx               ;Perform acceleration
                jmp arplrrun_nojleft
arplrrun_nojright:
                lda joystick                    ;Moving left while jumping?
                and #JOY_LEFT
                beq arplrrun_nojleft
                lda #-1
                sta actd,x
arplrrun_maxnegspd1:ldy #-2*8                   ;Max speed
                jsr slowaccactorx               ;Perform acceleration
arplrrun_nojleft:
                lda #$00
                sta temp3
                jsr checkjumpobst               ;Perform X-movement and check
                bcc arplrrun_jnoobst
                lda #$00
                sta actsx,x
arplrrun_jnoobst:lda actsy,x
                bpl arplrrun_noheadbump
                jsr moveactory
                jmp checkheadbump
arplrrun_noheadbump:
                jsr checklanding2               ;obstacles, also check
                bcs arplrrun_landed             ;"diagonal" landing :-)
                jsr moveactory
                jsr checklanding
                bcc arplrrun_notlanded
arplrrun_landed:lda #PLRFR_STAND
                sta actf,x
                lda actsx,x                     ;Halve X-speed
                tay
                asl
                tya
                ror
                sta actsx,x
arplrrun_notlanded:
                rts
arplrrun_onground:
                lda joystick
                and #JOY_UP
                beq arplrrun_nonewjump
                lda prevjoy
                and #JOY_UP+JOY_FIRE
                bne arplrrun_nonewjump
                lda #-4
                jsr getcharposinfooffset
                and #CI_CLIMB
                beq arplrrun_noclimbup
arplrrun_initclimb:
                lda #ACT_PLRCLIMB
                sta actt,x
                lda #$00
                sta actf,x
                sta actfd,x
                sta actsx,x
                lda #$80
                sta actxl,x
                rts
arplrrun_noclimbup:
                lda #-1
                jsr getcharposinfooffset
                and #CI_DOOR
                beq arplrrun_nodoor
                jsr checkdoor
                bcc arplrrun_nodoor
                jsr checkdooropen
                bcc arplrrun_nonewjump
                sty enterdoornum
arplrrun_npc:   lda #PLRFR_ENTER
                sta actf,x
                rts
arplrrun_nodoor:lda npccollnum
                beq arplrrun_nonpc
                sta commnum
                bpl arplrrun_npc
arplrrun_nonpc: lda #-1                         ;Lift player just off the
                jsr moveactorydirect            ;ground to prevent going
                lda #12
                jsr giveexp
arplrrun_jumpspeed:lda #$00                     ;thru walls in the beginning
                jmp arplrrun_initjump
arplrrun_nonewjump:
                lda joystick
                and #JOY_DOWN
                beq arplrrun_noduck
                lda joystick
                and #JOY_FIRE
                bne arplrrun_noduck
                jsr getcharposinfo              ;Duck or climb?
                and #CI_CLIMB
                bne arplrrun_initclimb
arplrrun_noclimbdown:
                jsr checkpickup
                lda #ACT_PLRDUCK
                sta actt,x
                lda #$00
                sta actf,x
                rts
arplrrun_noduck:lda joystick                    ;Move player right?
                and #JOY_RIGHT
                beq arplrrun_notr
                lda #$00
                sta actd,x
                lda joystick                    ;If attack in progress,
                and #JOY_FIRE                   ;can't move
                ora actattk,x
                bne arplrrun_notr
arplrrun_posacc:lda #$00                        ;Direction = right
arplrrun_maxposspd2:ldy #2*8                    ;Max speed
                jsr slowaccactorx               ;Perform acceleration
                jmp arplrrun_runanim
arplrrun_notr:  lda joystick
                and #JOY_LEFT
                beq arplrrun_notl
                lda #$80
                sta actd,x
                lda joystick                    ;If attack in progress,
                and #JOY_FIRE                   ;can't move
                ora actattk,x
                bne arplrrun_notl
arplrrun_negacc:lda #$00                        ;Direction = left
arplrrun_maxnegspd2:ldy #-2*8                   ;Max speed
                jsr slowaccactorx               ;Perform acceleration
                jmp arplrrun_runanim
arplrrun_notl:  lda #PLRFR_STAND
                sta actf,x
                lda #2                          ;If joystick centered,
                jsr brakeactorx                 ;brake speed
                jmp arplrrun_noframe
arplrrun_runanim:
                lda actsx,x
                asl
                bcc arplrrun_spdpos
                eor #$ff
                adc #$00
arplrrun_spdpos:adc #$20
                adc actfd,x
                sta actfd,x
                bcc arplrrun_noframe
                lda actf,x
                adc #$00                        ;Carry = 1, add one less
                cmp #PLRFR_JUMP
                bcc arplrrun_frnotover
                lda #4                          ;Give 4/256 point of
                jsr giveexp                     ;experience every time
                lda #PLRFR_RUN                  ;running animation wraps
arplrrun_frnotover:
                sta actf,x
arplrrun_noframe:
                jsr checksideobst               ;Perform X-movement and
                bcc arplrrun_noobst             ;check obstacles
                lda #$00
                sta actsx,x
                sta actfd,x
                lda #PLRFR_STAND                ;Set standing frame if
                sta actf,x                      ;hit obstacle
arplrrun_noobst:lda joystick
                and #JOY_UP                     ;If holding joystick in
                beq arplrrun_csnormal           ;the up direction, up will
                jsr checkstairs_preferup        ;be preferred direction in
                bcs arplrrun_nofall             ;stairs
                bcc arplrrun_initfall
arplrrun_csnormal:
                jsr checkstairs                 ;Check that there's ground
                bcs arplrrun_nofall             ;under feet
arplrrun_initfall:
                lda #8
arplrrun_initjump:
                sta actsy,x
                lda actbits,x
                ora #AB_JUMP
                sta actbits,x
                lda #ACT_PLRRUN
                sta actt,x
                rts
arplrrun_nofall:lda temp3
                and #CI_DOOR                    ;Walked into a "side door"?
                beq arplrrun_nosidedoor         ;(for horizontal movement from
                jsr checkdoor                   ;one level to another, like in
                bcc arplrrun_nosidedoor         ;MW2)
                sty enterdoornum
arplrrun_nosidedoor:
                rts

ar_plrduck:     jsr playerattack
                lda joystick
                and #JOY_DOWN+JOY_FIRE
                beq arplrduck_stand
                lda #2
                jsr brakeactorx
                lda joystick
                and #JOY_RIGHT
                beq arplrduck_notright
                lda #$00
                sta actd,x
                beq arplrduck_notleft
arplrduck_notright:
                lda joystick
                and #JOY_LEFT
                beq arplrduck_notleft
                lda #$80
                sta actd,x
                jmp arplrrun_noframe
arplrduck_stand:lda #ACT_PLRRUN
                sta actt,x
arplrduck_notleft:
                jmp arplrrun_noframe

ar_plrclimb:    lda joystick
                and #JOY_UP+JOY_DOWN
                bne arplrclimb_noexit
                lda joystick
                and #JOY_LEFT+JOY_RIGHT         ;Exit ladder?
                beq arplrclimb_done
                jsr getcharposinfo
                and #CI_GROUND
                beq arplrclimb_done
                lda #$00                        ;Clear speed to fix "exit-ladder"
                sta actsx,x                     ;bug if taken damage
                jsr dolanding
                jmp arplrduck_stand
arplrclimb_noexit:
                lda joystick
                and #JOY_UP
                beq arplrclimb_notup
                lda #-4
                jsr getcharposinfooffset
                and #CI_CLIMB
                beq arplrclimb_done
                ldy #-4*8
arplrclimb_common:
arplrclimb_speed:
                lda #$00
                clc
                adc actfd,x
                sta actfd,x
                bcc arplrclimb_done
                lda actf,x
                adc #$00                        ;Carry now 1
                and #$03
                sta actf,x
                lda #8                          ;Give a bit of experience
                jsr giveexp                     ;for each step climbed
                tya
                jmp moveactorydirect
arplrclimb_notup:
                lda joystick
                and #JOY_DOWN
                beq arplrclimb_notdown
                jsr getcharposinfo
                and #CI_CLIMB
                beq arplrclimb_done
                ldy #4*8
                bne arplrclimb_common
ar_donothing:
arplrclimb_notdown:
arplrclimb_done:rts

;Ŀ
;PLAYERATTACK                                                                 
;                                                                             
;Player's attack routine                                                      
;                                                                             
;Parameters: X:Player actor number                                            
;Returns: -                                                                   
;Modifies: A,Y,temp1-temp2                                                    
;

playerattack:   ldy invselect
                lda meleebreak
                beq plrattk_nobreak
                lda #$00
                sta meleebreak
                lda invtype,y
                cmp #ITEM_KNIFE
                bcc plrattk_nobreak
                cmp #ITEM_NUNCHAKU+1
                bcs plrattk_nobreak
                jsr removeitem
                lda #$00
                sta actattk,x
                sta actattkd,x
                stx plrattk_itemrestx+1
                ldy #100
                lda #<meleebreaktext
                ldx #>meleebreaktext
                jsr newmessage
                jmp plrattk_itemrestx
plrattk_nobreak:lda actattkd,x                  ;Decrement attack delay
                beq plrattk_nodelay
                dec actattkd,x
plrattk_nodelay:lda invtype,y
                cmp #ITEM_FIRSTWEAPON
                bcc plrattk_unarmed
                cmp #ITEM_LASTWEAPON+1
                bcc plrattk_armed
plrattk_unarmed:lda #$ff                        ;No gun drawn
                sta gunindex
                lda #$00
                sta actattk,x

                jsr getfireclick                ;Check use of other items
                bcc plrattk_noitemuse
                lda invtype,y
                ldy #ITEMUSETBLSIZE-1
plrattk_otherloop:
                cmp itemusetype,y
                beq plrattk_itemfound
                dey
                bpl plrattk_otherloop
                bmi plrattk_noitemuse
plrattk_itemfound:
                lda itemusejumplo,y
                sta plrattk_itemjsr+1
                lda itemusejumphi,y
                sta plrattk_itemjsr+2
                stx plrattk_itemrestx+1
plrattk_itemjsr:jsr $1000
plrattk_itemrestx:ldx #$00
plrattk_noitemuse:
plrattk_setframe:
                ldy actattk,x
                beq plrattk_setframe2
plrattk_setframecommon:
                lda attkframetbll,y
                sta fr_plrrun+PLRFR_JUMP*2
                sta fr_plrrun+PLRFR_STAND*2
                sta fr_plrduck
                lda attkframetblr,y
                sta fr_plrrun+PLRFR_JUMP*2+18
                sta fr_plrrun+PLRFR_STAND*2+18
                sta fr_plrduck+2
                rts
plrattk_setframe2:
                lda #PLRB+14
                sta fr_plrrun+PLRFR_JUMP*2
                lda attkframetbll,y
                sta fr_plrrun+PLRFR_STAND*2
                sta fr_plrduck
                lda #PLRB
                sta fr_plrrun+PLRFR_JUMP*2+18
                lda attkframetblr,y
                sta fr_plrrun+PLRFR_STAND*2+18
                sta fr_plrduck+2
                rts

plrattk_armed:  cmp #ITEM_PISTOL
                bcs plrattk_gun
                jmp plrattk_melee
plrattk_gun:    sbc #ITEM_PISTOL
                sta temp1
                ldy #$00
                lda joystick
                and #JOY_FIRE
                beq plrattk_noaimdown
                lda joystick
                and #JOY_UP
                beq plrattk_noaimup
                ldy #$01
plrattk_noaimup:lda joystick
                and #JOY_DOWN
                beq plrattk_noaimdown
                lda actt,x                      ;If ducking, joystick must
                cmp #ACT_PLRDUCK                ;be pushed diagonally down to
                bne plrattk_aimdown             ;aim down
                lda joystick
                and #JOY_LEFT+JOY_RIGHT
                beq plrattk_noaimdown
plrattk_aimdown:ldy #$02
plrattk_noaimdown:
                tya
                sta actattk,x
                asl
                adc actattk,x
                ldy temp1
                adc gunmultbl,y
                sta gunindex

                lda actattkd,x
                bne plrattk_noshoot
                lda joystick
                and #JOY_FIRE
                beq plrattk_noshoot
                ldy invselect
                lda invammolo,y                 ;Out of ammo?
                ora invammohi,y
                beq plrattk_noammo
                lda actattk,x
                ldy temp1
plrattk_shoot:  jsr actorshoot
                lda actattkd,x                  ;At least one bullet fired?
                beq plrattk_noshoot
                asl
                asl                             ;Give experience for each
                jsr giveexp                     ;shot fired
                ldy invselect
                lda invtype,y
                cmp #ITEM_GASFIST               ;Gasfist takes 2x power
                bne plrattk_nogasfist           ;on each shot
                lda #$02
                bne plrattk_decammo
plrattk_nogasfist:lda #$01
plrattk_decammo:jsr decreaseammo
plrattk_noshoot:ldy actattk,x
                jmp plrattk_setframecommon
plrattk_noammo: lda invtype,y                   ;Get weapon type
                tay
                lda itemammotbl,y
                beq plrattk_noshoot             ;No reload available
                jsr finditem                    ;Try to find bullets
                bcc plrattk_noshoot             ;Bullets not found
                lda invammohi,y
                bne plrattk_maxammo
                lda invammolo,y
                jmp plrattk_ammoready
plrattk_maxammo:lda #$99
plrattk_ammoready:
                sty temp4                       ;Y=item index of bullets
                ldy invselect
                jsr addammo
                ldy temp4
                jsr decreaseammo
                lda #GUNLOADDELAY
                sta actattkd,x
                bne plrattk_noshoot

plrattk_melee:  sta temp1
                ldy #$ff
                sty gunindex
                ldy #$03                ;Strike type 1 = hand behind head
                cmp #ITEM_FISTS
                beq plrattk_strike2
                cmp #ITEM_KNIFE
                bne plrattk_nostrike2
plrattk_strike2:ldy #$04                ;Strike type 2 = hand drawn backwards
plrattk_nostrike2:
                sty meleefrtbl+2
                lda actattkd,x
                bne plrattk_nomeleeattk
                jsr getfireclick
                bcc plrattk_nomeleeattk
                lda #SFX_MELEE
                jsr playsfx
                lda #$0b
                sta actattkd,x
plrattk_nomeleeattk:
                lda actattkd,x
                lsr
                lsr
                tay
                lda meleefrtbl,y
                sta actattk,x
                beq plrattk_nomeleespr
                lda meleemultbl-1,y
                sta temp2
                ldy temp1
                lda meleemultbl2-1,y
                clc
                adc temp2
                sta gunindex
plrattk_nomeleespr:
                lda actattkd,x                  ;When delay is 6 the melee
                cmp #MELEEDELAY                 ;attack will be activated
                bne plrattk_nomeleeattk2
                ldy temp1
                lda meleeblttbl-1,y
                cmp #BLT_GRENADE
                bne plrattk_nogrenade
                ldy invselect
                lda invammolo,y                 ;Out of ammo?
                ora invammohi,y
                beq plrattk_nomeleeattk2
                lda #96                         ;Give experience for each
                jsr giveexp                     ;grenade thrown
                lda #$00
                ldy #BLT_GRENADE
                jmp plrattk_shoot
plrattk_nogrenade:
                tay                             ;Regular melee attack;
                lda #$00                        ;no need to decrease ammo
                jsr actorshoot
plrattk_nomeleeattk2:
                jmp plrattk_setframe

;Ŀ
;DRAWPLAYERGUN                                                                
;                                                                             
;Will draw player's gun. DRAWACTORS jumps to this.                            
;                                                                             
;Parameters: -                                                                
;Returns: -                                                                   
;Modifies: A,X,Y,temp1                                                        
;

drawplayergun:  lda #$ff
                sta gunframe
                ldy gunindex
                bmi dpg_skip
                lda actt+ACTI_PLAYER
                cmp #ACT_PLRRUN
                bcc dpg_skip
                cmp #ACT_PLRCLIMB
                bcs dpg_skip
                lda actf+ACTI_PLAYER
                beq dpg_frameok
                cmp #PLRFR_JUMP
                bne dpg_skip
dpg_frameok:    ldx numsprites                  ;One free sprite?
                cpx #MAXSPR
                bcs dpg_skip
dpg_ok:         lda actd+ACTI_PLAYER
                bmi dpg_left
dpg_right:      lda gunsprtbl+2,y
                sta gunframe
                lda gunsprtbl,y
dpg_common:     jsr math_signadjust
                adc sprxl-2,x                   ;Carry is clear
                sta sprxl,x
                lda temp1
                adc sprxh-2,x
                sta sprxh,x
                lda gunsprtbl+1,y
                clc
                adc spry-2,x
                sta spry,x
                lda #GUNSPRITE
                sta sprf,x
                inc numsprites
dpg_skip:       rts
dpg_left:       lda gunsprtbl+2,y
                adc #GUNFRAMES
                sta gunframe
                lda gunsprtbl,y
                eor #$ff
                adc #$01
                clc
                jmp dpg_common

;Ŀ
;CHECKSCROLL                                                                  
;                                                                             
;Checks player's position on the screen and scrolls if necessary.             
;                                                                             
;Parameters: -                                                                
;Returns: -                                                                   
;Modifies: A,Y                                                                
;

checkscroll:    lda actxl
                sec
                sbc sprsubxl
                sta temp1
                lda actxh
                sbc sprsubxh
                sta temp2
                lda temp1
                sec
                sbc #$20
                lda temp2
                sbc #$00
                bpl cscr_xnotneg
                lda #$00
cscr_xnotneg:   cmp #$07
                bcc cscr_xnotover
                lda #$07
cscr_xnotover:  tay
                lda cscr_xtbl,y
                sta scrollsx
                lda actyl
                sec
                sbc sprsubyl
                sta temp1
                lda actyh
                sbc sprsubyh
                asl temp1
                rol
                sta temp2
                lda temp1
                sec
                sbc #$80
                lda temp2
                sbc #$05
                bpl cscr_ynotneg
                lda #$00
cscr_ynotneg:   cmp #$07
                bcc cscr_ynotover
                lda #$07
cscr_ynotover:  tay
                lda cscr_ytbl,y
                sta scrollsy
                rts

;Ŀ
;ADDSCORE                                                                     
;                                                                             
;Adds score to player. :-)                                                    
;                                                                             
;Parameters: A:Score to add (table index)                                     
;Returns: -                                                                   
;Modifies: A,Y                                                                
;

addscore:       tay
                sed
                lda score+3
                clc
                adc scoretbl3,y
                sta score+3
                lda score+2
                adc scoretbl2,y
                sta score+2
                lda score+1
                adc scoretbl1,y
                sta score+1
                lda score
                adc #$00
                sta score
                cld
                rts

;Ŀ
;INITTIME                                                                     
;                                                                             
;Inits game clock.                                                            
;                                                                             
;Parameters: A:Hours in BCD format                                            
;Returns: -                                                                   
;Modifies: A,X                                                                
;

inittime:       jsr atime_clmode
                lda #$00
                sta timemin
                sta timeframe
                rts

;Ŀ
;SELECTTM                                                                     
;                                                                             
;Teammember selection screen                                                  
;                                                                             
;Parameters: -                                                                
;Returns: C=1 ok, C=0 no active teammembers left (game over)                  
;Modifies: A,X,Y,all sorts of temp regs :-)                                   
;

selecttm:       jsr fademusic
                ldx #MAXTM-1
stm_loop1:      lda tmstat,x
                cmp #STAT_ACTIVE
                beq stm_nogameover
                dex
                bpl stm_loop1
                clc
                rts
stm_nogameover: lda #MUSIC_SELECT
                jsr playtune
                jsr cleartextscreen
                lda #$01                        ;Text color white
                jsr fadeallrows
                ldx #$00
                ldy #$00
stmcolorloop:   lda stmcolortbl,x
                beq stmcolordone
                lsr
                lsr
                lsr
                lsr
                sta temp1
stmcolorloop2:  lda stmcolortbl,x
                sta colors+3*40+5,y
                sta colors+6*40+5,y
                sta colors+9*40+5,y
                sta colors+12*40+5,y
                sta colors+15*40+5,y
                iny
                dec temp1
                bne stmcolorloop2
                inx
                bne stmcolorloop
stmcolordone:   lda #<selecttmtxt
                sta textptrlo
                lda #>selecttmtxt
                sta textptrhi
                ldy #$01
                jsr printtextc
                lda #$03                        ;Screen position
                sta temp4
                jsr stmclearrow
                ldx #$00                        ;Teammember counter
stm_loop2:      lda tmstat,x                    ;In the team?
                bne stm_ok
                jmp stm_next
stm_ok:         sta temp2
                stx temp1
                lda temp1
                tax
                asl
                asl
                tay
                sty textscreen+24*40            ;Upper part of the teammember's
                iny                             ;face
                sty textscreen+24*40+1
                sty temp3
                asl
                ora #$07
                tay
                ldx #$07
stm_loop3:      lda tmnametbl,y                 ;Print teammember name
                sta textscreen+24*40+3,x         ;and "HEALTH"-text
                lda healthtxt,x
                sta textscreen+24*40+16,x
                cpx #$03                        ;Print "OUT"-text if teammember
                bcs stm_skip1                   ;out of action
                lda temp2
                cmp #STAT_OUT
                bne stm_skip1
                lda outtxt,x
                bne stm_ok2
stm_skip1:      lda #$20
stm_ok2:        sta textscreen+24*40+12,x
                dey
                dex
                bpl stm_loop3
                ldx temp1
                lda tmhp,x
                lsr
                lsr
                ldy #222                        ;Draw health bar
                ldx #230
                jsr updp_drawmeter
                ldy temp4                       ;Copy first row onto screen
                jsr stmcopyrow
                ldy temp3
                iny
                sty textscreen+24*40             ;Lower part of the teammember's
                iny                             ;face
                sty textscreen+24*40+1
                ldx #$02
stm_loop4:      lda agilitytxt,x
                sta textscreen+24*40+3,x
                lda strengthtxt,x
                sta textscreen+24*40+10,x
                lda vitalitytxt,x
                sta textscreen+24*40+17,x
                lda exptxt,x
                sta textscreen+24*40+24,x
                dex
                bpl stm_loop4
                ldx temp1
                lda tmagility,x
                ldy #206                        ;Draw agility bar
                ldx #209
                jsr updp_drawmeter
                ldx temp1
                lda tmstrength,x
                ldy #213                        ;Draw strength bar
                ldx #216
                jsr updp_drawmeter
                ldx temp1
                lda tmvitality,x
                ldy #220                        ;Draw vitality bar
                ldx #223
                jsr updp_drawmeter
                ldx temp1
                lda tmexphi,x                   ;Draw experience points
                ldy #226
                jsr updp_drawdigit
                lda tmexplo,x
                ldy #228
                jsr updp_drawdigits
                ldy temp4                       ;Copy second row onto screen
                tya
                sta tmselrow,x
                iny
                clc
                adc #$03
                sta temp4
                jsr stmcopyrow

                ldx temp1
stm_next:       inx
                cpx #MAXTM
                bcs stm_downnotover
                jmp stm_loop2

stm_selectloop: jsr waitandupdate
                jsr titleflash
                jsr stmnameflash
                lda prevjoy
                bne stm_selectloop
                lda joystick
                and #JOY_UP
                beq stm_notup
                lda #$01
                jsr stmnameflash
stm_uploop:     dec teammember
                bpl stm_upnotover
                lda #MAXTM-1
                sta teammember
stm_upnotover:  ldx teammember
                lda tmstat,x
                cmp #STAT_ACTIVE
                bne stm_uploop
                beq stm_selectloop
stm_notup:      lda joystick
                and #JOY_DOWN
                beq stm_notdown
                lda #$01
                jsr stmnameflash
stm_downloop:   inc teammember
                lda teammember
                cmp #MAXTM
                bcc stm_downnotover
                lda #$00
                sta teammember
stm_downnotover:ldx teammember
                lda tmstat,x
                cmp #STAT_ACTIVE
                bne stm_downloop
                beq stm_selectloop
stm_notdown:    lda joystick
                and #JOY_FIRE
                bne stm_done
                lda keytype
                cmp #KEY_CR
                beq stm_done
                bne stm_selectloop
stm_done:       jsr initteammember
                jsr preventattack
                jsr cleartextscreen
                jsr fademusic_nowait
                jsr loadteammember
                lda #$00
                sta prevbossfight
                jsr playleveltune
                jsr drawscreen
                sec
                rts

stmnameflash:   pha
                ldx teammember
                ldy tmselrow,x
                lda screenrowtbllo,y
                sta stmnf_sta+1
                lda screenrowtblhi,y
                ora #>colors
                sta stmnf_sta+2
                ldx #$08
                pla
stmnf_sta:      sta $1000,x
                inx
                cpx #$10
                bcc stmnf_sta
                rts

stmcopyrow:     lda screenrowtbllo,y
                sta temp6
                lda screenrowtblhi,y
                ora #>textscreen
                sta temp7
                ldx #$00
                ldy #$05
stmcopyrowloop: lda textscreen+24*40,x
                sta (temp6),y
                iny
                inx
                cpx #$1e
                bcc stmcopyrowloop
stmclearrow:    ldy #39
                lda #$20
stmclearrowloop:sta textscreen+24*40,y
                dey
                bpl stmclearrowloop
                rts

;Ŀ
;GYMROUTINE                                                                   
;                                                                             
;Training at the gym                                                          
;                                                                             
;Parameters: -                                                                
;Returns: -                                                                   
;Modifies: A,X,Y,all sorts of temp regs :-)                                   
;

gymroutine:     ldx teammember
                lda tmhp,x
                cmp #MAXPLRHEALTH/2             ;Player healthy enough?
                bcs gym_healthok
                lda #<tooweaktext
                ldx #>tooweaktext
gym_msgcommon:  ldy #100
                jmp newmessage
gym_healthok:   lda #$00
                sta temp4
                sta temp5
gym_checkimprove:
                ldy temp4
                txa
                clc
                adc abilityindex,y
                tay
                lda tmagility,y
                cmp #$06                        ;At maximum level?
                bcs gym_notpossible
                sta temp3
                lda #$00
                sta temp1
gym_costloop:   sed
                clc
                adc #$50
                cld
                bcc gym_costnotover
                inc temp1
gym_costnotover:dec temp3
                bne gym_costloop
                ldy temp4
                sta improvecostlo,y
                lda temp1
                sta improvecosthi,y
                cmp tmexphi,x                   ;Enough experience?
                bcc gym_possible
                bne gym_notpossible
gym_checklow:   lda tmexplo,x
                cmp improvecostlo,y
                bcs gym_possible
gym_notpossible:lda #$00
                beq gym_abilitycommon
gym_possible:   lda #$01
                inc temp5
gym_abilitycommon:
                ldy temp4
                sta improvepossible,y
gym_nextability:iny
                sty temp4
                cpy #$03
                bcc gym_checkimprove
                lda temp5                       ;Any abilities to improve?
                bne gym_ok
                lda #<noexptext
                ldx #>noexptext
                bne gym_msgcommon
gym_ok:         lda #MUSIC_HISCORE              ;"Ripped to the max" :-)
                jsr playtune
                lda #$00
                sta menuchoice
                jmp gym_rightnotover
gym_loop:       lda menuchoice
                cmp #$03
                bne gym_noexittext
                lda #<exittext
                ldx #>exittext
                bne gym_selectmsgcommon
gym_noexittext: asl
                asl
                asl
                tay
                ldx #$00
gym_namecopy:   lda abilitynames,y
                sta improvetext+8,x
                iny
                inx
                cpx #$08
                bcc gym_namecopy
                ldx menuchoice
                lda improvecosthi,x
                ora #$30
                sta improvetext+21
                lda improvecostlo,x
                ldx #22+42
                jsr shop_print2digits
                lda #<improvetext
                ldx #>improvetext
gym_selectmsgcommon:
                ldy #$ff
                jsr newmessage
                jsr instantmessage
gym_controlloop:jsr waitandupdate_notoggle
                jsr getfireclick
                bcs gym_choiceok
                lda prevjoy
                bne gym_controlloop
                lda joystick
                and #JOY_RIGHT+JOY_DOWN
                beq gym_notright
gym_rightloop:  inc menuchoice
                lda menuchoice
                cmp #$04
                bcc gym_rightnotover
                lda #$00
                sta menuchoice
gym_rightnotover:
                ldx menuchoice
                lda improvepossible,x
                beq gym_rightloop
                jmp gym_loop
gym_notright:   lda joystick
                and #JOY_LEFT+JOY_UP
                beq gym_controlloop
gym_leftloop:   dec menuchoice
                bpl gym_leftnotover
                lda #$03
                sta menuchoice
gym_leftnotover:ldx menuchoice
                lda improvepossible,x
                beq gym_leftloop
                jmp gym_loop

gym_choiceok:   jsr removemessage
                ldy menuchoice
                cpy #$03
                beq gym_quit
gym_improve:    lda loadedlevel         ;No disappearing in the "garage"
                cmp #LEVEL_OUTPOST
                beq gym_nodisappear
                lda actf+ACTI_PLAYER
                ora #$80
                sta actf+ACTI_PLAYER
                jsr drawactors          ;Player disappears to the gym
                jsr sortsprites
gym_nodisappear:lda #59                 ;Spend 59 minutes of game time
                jsr gym_delaysubroutine
                ldx teammember
                ldy menuchoice
                sed
                lda tmexplo,x
                sec
                sbc improvecostlo,y
                sta tmexplo,x
                lda tmexphi,x
                sbc improvecosthi,y
                sta tmexphi,x
                cld
                txa
                clc
                adc abilityindex,y
                tax
                inc tmagility,x
                jsr waitandupdate
                jsr itemcapacity                        ;Strength might have
gym_quit:       jmp playleveltune                       ;changed

gym_delaysubroutine:
                sta spendtimecount
gym_delay2:     lda #$03
                jsr delay2
                lda #50
                sta temp7
gym_delay1:     jsr processtm           ;Healing & time advance
                dec temp7
                bne gym_delay1
                dec spendtimecount
                bne gym_delay2
                rts

;Ŀ
;CHECKDOOR                                                                    
;                                                                             
;Checks if player has entered a door                                          
;                                                                             
;Parameters: X:Player actor number                                            
;Returns: C=0 no door, C=1 door found, Y:Number of destination door           
;Modifies: A,Y                                                                
;

checkdoor:      lda actxh,x
                sta chkd_xcmp+1
                lda actyh,x
                sec
                sbc #$01
                sta chkd_ycmp+1
                lda levelnum
                sta chkd_lcmp+1
                ldy #NUMDOORS-1                 ;Actually, door 0 will not be
chkd_loop:      lda doorl,y                     ;checked but it's the game
chkd_lcmp:      cmp #$00                        ;beginning position so it
                beq chkd_levelok                ;doesn't matter
                dey
                bne chkd_loop
                clc
                rts
chkd_levelok:   lda doorx,y
chkd_xcmp:      cmp #$00
                beq chkd_xok
                dey
                bne chkd_loop
                clc
                rts
chkd_xok:       lda doory,y
chkd_ycmp:      cmp #$00
                beq chkd_ok
                dey
                bne chkd_loop
                clc
                rts
chkd_ok:        lda doord,y
                tay
                sec
                rts

;Ŀ
;CHECKDOOROPEN                                                                
;                                                                             
;Checks if the door player entered really can be entered.                     
;If it's a time-limited door will also set the limits upon which player will  
;be removed from the place.                                                   
;                                                                             
;Parameters: Y:Destination door number                                        
;Returns: C=0 cannot be entered, C=1 can be entered                           
;Modifies: A,temp1-temp2                                                      
;

cdo_elsewhere:  lda plotbits+1                  ;Check for PB_FINALDOOR
                and #$01
                bne cdo_finaldoorok
                lda #<finaldoortext
                ldx #>finaldoortext
                jmp cdo_msgcommon
cdo_checkkey:   lda doorlimithigh,x
                beq cdo_elsewhere
                jsr finditem
                ldy temp2
cdo_finaldoorok:bcs cdo_freedoor
                lda doorlimitlow,x
                and #$01
                bne cdo_keycardmsg
                lda #<keytext
                ldx #>keytext
                bne cdo_msgcommon
cdo_keycardmsg: lda #<keycardtext
                ldx #>keycardtext
                bne cdo_msgcommon

checkdooropen:  stx temp1
                sty temp2
                ldx #$00
cdo_loop:       lda doorlimitnum,x
                cmp #$ff
                beq cdo_freedoor
                tya
                cmp doorlimitnum,x
                beq cdo_found
                inx
                bne cdo_loop
cdo_othercheck: lda timehour
                cmp doorlimitlow,x
                bcs cdo_open
                lda doorlimithigh,x
                and #$7f
                cmp timehour
                bcc cdo_closed
                beq cdo_closed
                bcs cdo_open
cdo_found:      lda doorlimitlow,x
                bmi cdo_checkkey
                cmp doorlimithigh,x
                bcs cdo_othercheck              ;Is it a place which is open
                lda daynumber                   ;On Sunday everything is closed
                cmp #$06                        ;(except bars etc.)
                beq cdo_closed
                lda timehour                    ;during night? (check must be
                cmp doorlimitlow,x              ;reversed)
                bcc cdo_closed
                lda doorlimithigh,x
                and #$7f
                cmp timehour
                beq cdo_closed
                bcc cdo_closed
cdo_open:       lda doorlimithigh,x             ;If 7th bit set in closing time,
                bmi cdo_resetar                 ;reset the autoremove
                sta autoremovetime
                sty autoremovedoornum
cdo_alldone:    ldx temp1
                sec
                rts
cdo_freedoor:   cpy #DOOR_SPECIAL               ;A special door?
                bcs cdo_alldone                 ;It might be inside so don't
cdo_resetar:    lda #$00                        ;reset the autoremove-status
                sta autoremovedoornum
                jmp cdo_alldone

cdo_closed:     lda #<closedtext
                ldx #>closedtext
cdo_msgcommon:  ldy #100
                jsr newmessage
                ldx temp1
                ldy temp2
                clc
                rts
;Ŀ
;CENTERPLAYER                                                                 
;                                                                             
;Centers the screen to the player actor.                                      
;Moves player first downwards until solid ground is found                     
;(for doors not aligned on block boundary vertically)                         
;                                                                             
;Parameters: -                                                                
;Returns: -                                                                   
;Modifies: A,X,Y                                                              
;

centerplayer:   ldx #$00
                jsr getcharposinfo
                and #CI_GROUND
                bne cplr_groundok
                lda #8*8
                jsr moveactorydirect
                jmp centerplayer
cplr_groundok:  lda #$00
                sta blockx
                sta blocky
                lda mapsizex
                sec
                sbc #$0a
                sta cplr_notleft+1
                lda actxh
                sec
                sbc #$04
                bcs cplr_notleft
                lda #$00
cplr_notleft:   cmp #$00
                bcc cplr_notright
                inc blockx
                lda cplr_notleft+1
cplr_notright:  sta mapx
                lda actyh
                sec
                sbc #$04
                bcs cplr_notup
                lda #$00
cplr_notup:     sta mapy
                rts

;Ŀ
;MOVETODOOR                                                                   
;                                                                             
;Moves player actor to door position                                          
;                                                                             
;Parameters: X:Destination door number                                        
;Returns: -                                                                   
;Modifies: A,Y                                                                
;

movetodoor:     stx lastdoornum
                lda doorx,x
                sta actxh+ACTI_PLAYER
                lda #$80
                sta actxl+ACTI_PLAYER
                lda doory,x
                clc
                adc #$01
                sta actyh+ACTI_PLAYER
                lda #$00
                sta actyl+ACTI_PLAYER
                lda doorl,x
                sta levelnum
                rts

;Ŀ
;RANDOM                                                                       
;                                                                             
;Returns a 8bit pseudorandom number.                                          
;                                                                             
;Parameters: -                                                                
;Returns: A:number ($00-$ff)                                                  
;Modifies: A                                                                  
;

random:         inc randomadd+1
                bne randomseed
                lda randomadd+2
                cmp #>randomareaend-1
                bcc randomok
                lda #>randomareastart-2
randomok:       adc #$01
                sta randomadd+2
randomseed:     lda #$00
randomadd:      eor randomareastart
                adc #$3b
                sta randomseed+1
                rts

;Ŀ
;INITPWD                                                                      
;                                                                             
;Clears the password and resets byte and bit indexes.                         
;                                                                             
;Parameters: -                                                                
;Returns: -                                                                   
;Modifies: A,X                                                                
;

initpwd:        lda #$00
                sta pwdbitcount
                sta pwdbytecount
                ldx #PWDBYTESIZE-1
ipwd_loop:      sta pwd,x
                dex
                bpl ipwd_loop
                rts

;Ŀ
;STOREPWDBITS                                                                 
;                                                                             
;Stores up to 8 bits of data to the password                                  
;                                                                             
;Parameters: A:Byte to be stored                                              
;            X:How many bits                                                  
;Returns: -                                                                   
;Modifies: A,X,temp1,temp2                                                    
;

storefullbyte:  ldx #$08
storepwdbits:   sta temp1
                sty temp2
spb_bitloop:    ror temp1                       ;Bit to carry
                bcc spb_skipbit
                ldy pwdbitcount
                lda pwdbittbl,y
                ldy pwdbytecount
                ora pwd+1,y
                sta pwd+1,y
spb_skipbit:    jsr pwdnextbit
                dex
                bne spb_bitloop
                ldy temp2
                rts
pwdnextbit:     ldy pwdbitcount
                iny
                cpy #$05                        ;All bits gone thru?
                bcc pwdbit_notover
                ldy #$00
                inc pwdbytecount                ;Move to next byte
pwdbit_notover: sty pwdbitcount
                rts

;Ŀ
;GETPWDBITS                                                                   
;                                                                             
;Gets up to 8 bits of data from the password                                  
;                                                                             
;Parameters: X:How many bits                                                  
;Returns: A:Byte that was read                                                
;Modifies: A,X,temp1,temp2,temp3                                              
;

getfullbyte:    ldx #$08
getpwdbits:     lda #$00
                sta temp1
                sty temp2
                sta temp3
gpb_bitloop:    ldy pwdbytecount
                lda pwd+1,y
                ldy pwdbitcount
                and pwdbittbl,y
                beq gpb_skipbit
                ldy temp3
                lda pwdbittbl,y
                ora temp1
                sta temp1
gpb_skipbit:    jsr pwdnextbit
                inc temp3
                dex
                bne gpb_bitloop
                ldy temp2
                lda temp1
                rts


;Ŀ
;ENCRYPTPWD                                                                   
;                                                                             
;Calculates checksum and encrypts the password                                
;                                                                             
;Parameters: -                                                                
;Returns: -                                                                   
;Modifies: A,X,Y                                                              
;

encryptpwd:     jsr pwdchecksum
                sta pwd
pwdeor:         tay
                ldx #PWDBYTESIZE-2
epwd_loop2:     clc
                adc #$05
                and #$1f
                tay
                eor pwd+1,x
                sta pwd+1,x
                tya
                dex
                bpl epwd_loop2
                rts
pwdchecksum:    ldx #PWDBYTESIZE-2
                lda #$19
                clc
epwd_loop1:     adc pwd+1,x
                dex
                bpl epwd_loop1
                and #$1f
                rts

;Ŀ
;DECRYPTPWD                                                                   
;                                                                             
;Decrypts password and verifies the checksum                                  
;                                                                             
;Parameters: -                                                                
;Returns: C=1 checksum OK, C=0 checksum wrong                                 
;Modifies: A,X,Y                                                              
;

decryptpwd:     lda pwd
                jsr pwdeor
                jsr pwdchecksum
                cmp pwd
                beq dpwd_ok
                clc
dpwd_ok:        lda #$00
                sta pwdbitcount
                sta pwdbytecount
                rts

divideby10:     ldx #$04
d10_loop:       lsr temp1
                ror
                dex
                bne d10_loop
                rts

multiplyby10:   ldx #$00
                stx temp1
                ldx #$04
m10_loop:       asl
                rol temp1
                dex
                bne m10_loop
                rts

;Ŀ
;GENERATEPWD                                                                  
;                                                                             
;Generates the password from game variables, using routines above             
;                                                                             
;Parameters: -                                                                
;Returns: -                                                                   
;Modifies: A,X,Y                                                              
;

generatepwd:    jsr initpwd
                lda plotbits
                jsr storefullbyte
                ldx #$05
                lda plotbits+1
                jsr storepwdbits
                lda lastdoornum
                jsr storefullbyte
                lda actd+ACTI_PLAYER
                rol
                rol
                ldx #$01
                jsr storepwdbits
                lda daynumber
                ldx #$03
                jsr storepwdbits
                lda timehour
                ldx #$06
                jsr storepwdbits
                lda timemin
                ldx #$07
                jsr storepwdbits
                lda teammember
                ldx #$03
                jsr storepwdbits
                ldy #$00
gpwd_teamloop:  ldx #$01
                lda tmstat,y
                beq gpwd_notactive
                txa
                jsr storepwdbits
                lda tmagility,y
                ldx #$03
                jsr storepwdbits
                lda tmstrength,y
                ldx #$03
                jsr storepwdbits
                lda tmvitality,y
                ldx #$03
                jsr storepwdbits
                lda tmexphi,y
                sta temp1
                lda tmexplo,y
                jsr divideby10
                ldx #$06
                jsr storepwdbits
                jmp gpwd_nexttm
gpwd_notactive: jsr storepwdbits
gpwd_nexttm:    iny
                cpy #MAXTM
                bcc gpwd_teamloop
                lda #ITEM_FIRSTWEAPON+1         ;Fists exist always :-)
                ldx #ITEM_LASTWEAPON+1
                jsr gpwd_storeitems
                lda #FIRSTIMPORTANTITEM
                ldx #LASTIMPORTANTITEM+1
                jsr gpwd_storeitems
                lda #ITEM_CREDITS
                jsr finditem
                lda #$00
                bcc gpwd_nocredits
                lda invammohi,y
                cmp #$03                        ;If more than 300 credits,
                bcc gpwd_creditshiok            ;store as 300
                lda #$30
                bne gpwd_nocredits
gpwd_creditshiok:sta temp1
                lda invammolo,y
                jsr divideby10
gpwd_nocredits: ldx #$06
                jsr storepwdbits
                jmp encryptpwd

gpwd_storeitems:sta gpwd_itemloop+1
                stx gpwd_cmp+1
gpwd_itemloop:  lda #$00
gpwd_cmp:       cmp #$00
                bcs gpwd_itemsdone
                tax
                jsr finditem
                bcc gpwd_noitem
                lda itemaddtbl,x                ;Ammo-less item?
                beq gpwd_hasitem
                lda invammolo,y                 ;Ammo in weapon?
                ora invammohi,y
                bne gpwd_hasitem
                lda itemammotbl,x               ;Ammo exists but not in weapon?
                jsr finditem
                bcs gpwd_hasitem
gpwd_noitem:    lda #$00
                beq gpwd_itemok
gpwd_hasitem:   lda #$01
gpwd_itemok:    ldx #$01
                jsr storepwdbits
                inc gpwd_itemloop+1
                bpl gpwd_itemloop
gpwd_itemsdone: rts

;Ŀ
;LOADFROMPWD                                                                  
;                                                                             
;"Loads" the game status from the password. Note! INITGAME must have been     
;called before to do some basic initting.                                     
;                                                                             
;Parameters: -                                                                
;Returns: C=1 OK, C=0 wrong checksum or wrong data                            
;Modifies: A,X,Y                                                              
;

lfp_fail:       clc
                rts
loadfrompwd:    jsr decryptpwd
                bcc lfp_fail
                jsr getfullbyte
                sta plotbits
                ldx #$05
                jsr getpwdbits
                sta plotbits+1
                jsr getfullbyte
                sta lastdoornum
                ldx #$01
                jsr getpwdbits
                ror
                ror
                sta actd+ACTI_PLAYER
                ldx #$03
                jsr getpwdbits
                cmp #$07                        ;Illegal day?
                bcs lfp_fail
                sta daynumber
                ldx #$06
                jsr getpwdbits
                cmp #$24                        ;Illegal game hour?
                bcs lfp_fail
                sta timehour
                ldx #$07
                jsr getpwdbits
                cmp #$60                        ;Illegal game minute?
                bcs lfp_fail
                sta timemin
                ldx #$03
                jsr getpwdbits
                cmp #MAXTM                      ;Illegal teammember number?
                bcs lfp_fail
                sta teammember
                ldy #$00
lfp_teamloop:   ldx #$01
                jsr getpwdbits
                asl
                sta tmstat,y
                beq lfp_skiptm
                ldx #$03
                jsr getpwdbits
                sta tmagility,y
                ldx #$03
                jsr getpwdbits
                sta tmstrength,y
                ldx #$03
                jsr getpwdbits
                sta tmvitality,y
                ldx #$06
                jsr getpwdbits
                jsr multiplyby10
                sta tmexplo,y
                lda temp1
                sta tmexphi,y
lfp_skiptm:     iny
                cpy #MAXTM
                bcc lfp_teamloop
                jsr initinventory
                lda #ITEM_FIRSTWEAPON+1         ;Fists exist always :-)
                ldx #ITEM_LASTWEAPON+1
                jsr lfp_items
                lda #FIRSTIMPORTANTITEM
                ldx #LASTIMPORTANTITEM+1
                jsr lfp_items
                ldx #$06
                jsr getpwdbits
                beq lfp_creditsskip
                pha
                ldx #ITEM_CREDITS               ;First add a bogus value
                lda #$00
                jsr additem
                lda #ITEM_CREDITS
                jsr finditem
                pla
                bcc lfp_creditsskip             ;If something fucks up...
                jsr multiplyby10
                sta invammolo,y
                lda temp1
                sta invammohi,y
lfp_creditsskip:jsr itemcapacity
                jsr encryptpwd                  ;Re-encrypt password now :-)
                sec
                rts

lfp_items:      sta lfp_itemnum+1
                stx lfp_cmp+1
lfp_itemloop:   ldx #$01
                jsr getpwdbits
                beq lfp_itemskip
lfp_itemnum:    ldx #$00
                lda itemaddtbl,x
                jsr additem
lfp_itemskip:   inc lfp_itemnum+1
                lda lfp_itemnum+1
lfp_cmp:        cmp #$00
                bcc lfp_itemloop
                rts


;Ŀ
;PRINTPWD                                                                     
;                                                                             
;Prints the password to the screen.                                           
;                                                                             
;Parameters: -                                                                
;Returns: -                                                                   
;Modifies: A,X,Y,temp1,temp2                                                  
;

printpwd:       ldx #$00
                ldy #$00
ppwd_loop:      sty temp1
                ldy pwd,x
                lda pwdlettertbl,y
                ldy temp1
                sta textscreen+8*40+11,y
                cpx hiscorecursor
                bne ppwd_colorskip
                sty temp2
ppwd_colorskip: inx
                iny
                txa
                and #$03
                bne ppwd_skip1                  ;Letters in groups of four
                iny
ppwd_skip1:     txa
                and #$0f                        ;Change row?
                bne ppwd_skip2
                tya
                clc
                adc #60
                tay
ppwd_skip2:     cpx #PWDBYTESIZE
                bcc ppwd_loop
                rts

;Ŀ
;SETPLOTBIT                                                                   
;                                                                             
;Sets a certain plot bit                                                      
;                                                                             
;Parameters: A:Bit number                                                     
;Returns: -                                                                   
;Modifies: A,temp1,temp2                                                      
;

setplotbit:     jsr plotbitcommon
                ora orbittbl,x
plotbitcommon2: sta plotbits,y
plotbitcommon3: ldx temp1
                ldy temp2
                rts

plotbitcommon:  stx temp1
                sty temp2
                pha
                lsr
                lsr
                lsr
                tay
                pla
                and #$07
                tax
                lda plotbits,y
                rts

;Ŀ
;CLEARPLOTBIT                                                                 
;                                                                             
;Clears a certain plot bit                                                    
;                                                                             
;Parameters: A:Bit number                                                     
;Returns: -                                                                   
;Modifies: A,temp1,temp2                                                      
;

clearplotbit:   jsr plotbitcommon
                and andbittbl,x
                jmp plotbitcommon2

;Ŀ
;TOGGLEPLOTBIT                                                                
;                                                                             
;Toggles a certain plot bit                                                   
;                                                                             
;Parameters: A:Bit number                                                     
;Returns: -                                                                   
;Modifies: A,temp1,temp2                                                      
;

toggleplotbit:  jsr plotbitcommon
                eor orbittbl,x
                jmp plotbitcommon2

;Ŀ
;CHECKPLOTBIT                                                                 
;                                                                             
;Checks if a plot bit is true or false.                                       
;                                                                             
;Parameters: A:Bit number                                                     
;Returns: C=0 false, C=1 true                                                 
;Modifies: A,temp1,temp2                                                      
;

checkplotbit:   jsr plotbitcommon
                clc
                and orbittbl,x
                beq cpb_ok
                sec
cpb_ok:         jmp plotbitcommon3

;Ŀ
;HACKMINIGAME                                                                 
;                                                                             
;V1.3 addition: allows to proceed without bootdisk                            
;                                                                             
;Parameters: -                                                                
;Returns: A=1 success                                                         
;Modifies: A,Y                                                                
;

hackminigame:   jsr removemessage
                ldx #25         ;Initial swaptable (A-Z)
hmg_loop:       txa
                ora #$40
                sta screen1+24*40,x
                dex
                bpl hmg_loop
                lda #$00
                sta rastercount
                lda #10         ;Number of shuffles
                sta temp1
hmg_shuffle:    jsr hmg_getvalidletter
                tay
                jsr hmg_getvalidletter
                tax
                jsr hmg_swap
                dec temp1
                bne hmg_shuffle   ;Until all shuffles done
                lda #$60
                sta hmg_swaptime
hmg_mainloop:   ldx #19
hmg_print:      lda hmg_hacktext1,x
                jsr hmg_convert
                sta screen1+20*40+10,x
                lda hmg_hacktext2,x
                jsr hmg_convert
                sta screen1+21*40+10,x
                dex
                bpl hmg_print
                ldx #39
hmg_checkvictory:
                lda hmg_hacktext1,x
                jsr hmg_convert
                cmp hmg_hacktext1,x     ;Letter stays same in conversion?
                bne hmg_novictory
                dex
                bne hmg_checkvictory
hmg_victory:    lda #$00                ;If all letters stay, victory
                sta rastercount
hmg_victorywait:lda rastercount         ;Wait a little bit
                cmp #10
                bcc hmg_victorywait
                jsr removemessage
                lda #$01
                rts
hmg_novictory:
hmg_swap1:      lda #<hmg_text1
                sta textptrlo
                lda #>hmg_text1
                sta textptrhi
                ldx #15
                ldy #22
                jsr printtext
                lda #<hmg_text2
                sta textptrlo
                lda #>hmg_text2
                sta textptrhi
                jsr hmg_getletter
                sta hmg_swapl1+1
hmg_swap2:      lda #<hmg_text3
                sta textptrlo
                lda #>hmg_text3
                sta textptrhi
                jsr hmg_getletter
                sta hmg_swapl2+1
hmg_swapl1:     ldx #$00
hmg_swapl2:     ldy #$00
                jsr hmg_swap
                jmp hmg_mainloop

hmg_getletter:  ldx #10
                ldy #22
                jsr printtext
hmg_glloop:     lda rastercount
                cmp #50
                bcc hmg_notime
                lda #$00
                sta rastercount
                sed
                lda hmg_swaptime
                sbc #$01
                sta hmg_swaptime
                cld
                beq hmg_outoftime
hmg_notime:     lda hmg_swaptime
                ldy #3*40+28
                jsr updp_drawdigits
                jsr getcontrols
                ldx keytype
                bmi hmg_glloop
                lda asciitbl,x
                cmp #32
                beq hmg_abort
                ldy #25
hmg_reversemap: cmp screen1+24*40,y
                beq hmg_reversemapfound
                dey
                bpl hmg_reversemap
hmg_reversemapfound:
                tya
                ora #$40
                jsr hmg_checkletter
                bcc hmg_glloop
hmg_letterok:   rts
hmg_abort:
hmg_outoftime:  pla
                pla
                jsr removemessage
                lda #$00
                rts


hmg_convert:    cmp #64
                bcc hmg_ok1
                tay
                lda screen1+24*40-$40,y
hmg_ok1:        rts

hmg_getvalidletter:
                jsr random
                and #$1f
                ora #$40
                jsr hmg_checkletter
                bcc hmg_getvalidletter
                rts

hmg_checkletter:sty temp2
                ldy #39
hmg_clloop:     cmp hmg_hacktext1,y
                beq hmg_found
                dey
                bpl hmg_clloop
                clc
hmg_found:      ldy temp2
                rts

hmg_swap:       lda screen1+24*40-$40,x ;Swap letters
                pha
                lda screen1+24*40-$40,y
                sta screen1+24*40-$40,x
                pla
                sta screen1+24*40-$40,y
                rts

