;ͻ
;Metal Warrior III by Cadaver: Title screen routines                          
;Started in 5/2000!                                                           
;ͼ

FIRSTTITLEPHASE = 0
TITLE_PRESENTS1 = 0
TITLE_PRESENTS2 = 1
TITLE_LOGO      = 2
TITLE_HISCORE   = 3
TITLE_CREDITS   = 4
TITLE_CONTROLS  = 5
TITLE_CONTACTS  = 6
LASTTITLEPHASE  = 6

;Ŀ
;SHOWPASSWORD                                                                 
;                                                                             
;Password display at game over                                                
;                                                                             
;Parameters: -                                                                
;Returns: -                                                                   
;Modifies: A,X,Y,temp registers :-)                                           
;

showpassword:   lda #MUSIC_SELECT
                jsr playtune
                jsr cleartextscreen
                lda #<pwdtext
                sta textptrlo
                lda #>pwdtext
                sta textptrhi
                ldy #$06
                jsr printtextc
                jsr printpwd
                lda #$00
                sta titlefade
                lda #$ff
                sta hiscorecursor
showpwdloop:    jsr waitandupdate
                jsr menu_fadein
                jsr getfireclick
                bcc showpwdloop
                jsr fademusic_nowait
showpwdloop2:   jsr waitandupdate
                jsr menu_fadeout
                lda titlefade
                bne showpwdloop2
                rts

;Ŀ
;ENTERPASSWORD                                                                
;                                                                             
;Password entry loop                                                          
;                                                                             
;Parameters: -                                                                
;Returns: -                                                                   
;Modifies: A,X,Y,temp registers :-)                                           
;

enterpassword:  jsr cleartextscreen
                lda #<enterpwdtext
                sta textptrlo
                lda #>enterpwdtext
                sta textptrhi
                ldy #$06
                jsr printtextc
                lda #$00
                sta hiscorecursor
                sta titlefade
                sta titlefire
enterpwdloop:   jsr waitandupdate_notoggle
                jsr menu_fadein
                jsr printpwd
                jsr getfireclick
                bcs showpwdloop2
                jsr titleflash
                ldy temp2
                sta colors+8*40+11,y
                ldx keytype
                bmi enterpwdloop
                ldy hiscorecursor
                lda asciitbl,x
                beq enterpwdloop
                bmi enterpwdback
                cmp #13
                beq showpwdloop2
                cmp #32
                beq enterpwdforward
                ldx #31
enterpwdsearch: cmp pwdlettertbl,x
                beq enterpwdfound
                dex
                bpl enterpwdsearch
                bmi enterpwdloop
enterpwdfound:  txa
                sta pwd,y
enterpwdforward:lda hiscorecursor
                cmp #PWDBYTESIZE-1
                bcs enterpwdloop
                inc hiscorecursor
                jmp enterpwdcolor
enterpwdback:   cpy #$00
                beq enterpwdloop
                dec hiscorecursor
enterpwdcolor:  ldy temp2
                ldx titlefade
                lda flashcolortbl,x
                sta colors+8*40+11,y
                jmp enterpwdloop


;Ŀ
;ENTERHISCORE                                                                 
;                                                                             
;Hiscore entry loop                                                           
;                                                                             
;Parameters: -                                                                
;Returns: -                                                                   
;Modifies: A,X,Y,temp registers :-)                                           
;

enterhiscore:   lda #$04                        ;Check that player's score is
                sta hiscorerow                ;high enough
                lda #$00
                sta hiscoreindex
ehsc_checkloop: ldx #$00
                ldy hiscoreindex
ehsc_checkloop2:lda score,x                     ;Compare two digits at a time
                cmp hiscores+HSCNAMELENGTH,y
                bcc ehsc_chklow
                bne ehsc_found
                iny
                inx
                cpx #$04
                bcc ehsc_checkloop2
ehsc_chklow:    inc hiscorerow
                lda hiscoreindex
                clc
                adc #$10
                sta hiscoreindex
                cmp #160
                bcc ehsc_checkloop
                rts                             ;No hiscore
ehsc_found:     ldy #144                        ;Shift other hiscores downwards
                bne ehsc_shiftcmp
ehsc_shiftloop: lda hiscores,y
                sta hiscores+16,y
ehsc_shiftcmp:  cpy hiscoreindex
                beq ehsc_shiftdone
                dey
                jmp ehsc_shiftloop
ehsc_shiftdone: ldx #$00
                stx hiscorecursor
                stx titlefade
                stx titlefire
ehsc_clearname: lda #"."                        ;Clear player's name & store
                cpx #HSCNAMELENGTH              ;player's score
                bcc ehsc_clearname2
                lda score-HSCNAMELENGTH,x
ehsc_clearname2:sta hiscores,y                  ;Clear player's name
                iny
                inx
                cpx #$10
                bcc ehsc_clearname
                jsr cleartextscreen
                lda #MUSIC_HISCORE              ;Start playing
                jsr playtune                    ;"Ripped to the max" :-)
                jsr printhiscore
ehsc_loop:      jsr ehsc_fadein
                jsr titleflash
                ldx hiscorerow
                jsr setrowcolor
                ldx keytype
                bmi ehsc_loop
                lda asciitbl,x
                beq ehsc_loop
                cmp #13
                beq ehsc_done
                bmi ehsc_delete
ehsc_write:     tay
                lda hiscorecursor
                cmp #HSCNAMELENGTH
                bcs ehsc_loop
                inc hiscorecursor
                sec
ehsc_writecommon:
                adc hiscoreindex
                tax
                tya
                sta hiscores-1,x
ehsc_writedone: jsr printhiscore
                jmp ehsc_loop
ehsc_delete:    lda hiscorecursor
                beq ehsc_loop
                dec hiscorecursor
                clc
                ldy #"."
                bne ehsc_writecommon
ehsc_done:      jsr dtfo
                jsr fadeallrows
                lda titlefade
                bne ehsc_done
                jsr fademusic
                jsr cleartextscreen
                jmp loader_savehisc

;Ŀ
;TITLESCREEN                                                                  
;                                                                             
;Title screen loop                                                            
;                                                                             
;Parameters: -                                                                
;Returns: -                                                                   
;Modifies: A,X,Y                                                              
;

titlescreen:    lda #$00
                sta titlefire
                sta titleexit
titleloop1:     lda #$00
                sta titlefade
                jsr cleartextscreen
                lda #<firetext
                sta textptrlo
                lda #>firetext
                sta textptrhi
                ldy #SCROLLROWS-2
                jsr printtextc
                ldx titlephase
                lda tdurtblhi,x
                sta titledurhi
                lda tdurtbllo,x
                sta titledurlo
                lda trouttbllo,x
                sta titlejump+1
                lda trouttblhi,x
                sta titlejump+2
titlejump:      jsr $1000
titleloop2:     jsr waitandupdate
                jsr random                      ;To make each game different,
                ldx cheatindex                  ;Check for cheatstring
                lda keytype
                bmi titlenocheatkey
                cmp cheatstring,x               ;Correct key?
                bne titlecheatend
                inx
                lda cheatstring,x               ;$ff indicates end of cheatstring
                bpl titlenocheatkey
                lda energycheat
                eor #$01
                sta energycheat
titlecheatend:  ldx #$00
titlenocheatkey:stx cheatindex
                jsr getfireclick                ;call random here
                bcc title_nofire
                lda titleexit
                bne title_nofire
                inc titleexit
                lda #$00
                sta titledurhi
                lda #$20
                sta titledurlo
title_nofire:   jsr dotitlefade
                bcc title_nofade
                pha
                ldy titlephase
                cpy #TITLE_LOGO
                beq title_logocol
                bcc title_nosprcol
                jsr setbigtmcolors
                jmp title_nosprcol
title_logocol:  jsr setlogocolors
title_nosprcol: pla
                ldx #SCROLLROWS-2
                jsr fadeallrows2
title_nofade:   jsr titleflash
                ldx #SCROLLROWS-2
                jsr setrowcolor
                lda titledurlo
                bne title_notover
                dec titledurhi
                bmi title_gotonext
title_notover:  dec titledurlo
                jmp titleloop2
title_gotonext: lda titleexit
                bne title_doexit
                lda titlephase
                clc
                adc #$01
                cmp #LASTTITLEPHASE+1
                bcc title_notover1
                lda #FIRSTTITLEPHASE
title_notover1: sta titlephase
                jmp titleloop1
title_doexit:   rts

titleflash:     lda titlefire
                inc titlefire
                and #$1f
                tax
                lda flashcolortbl,x
                rts

title_presents1:lda #<prtext1
                sta textptrlo
                lda #>prtext1
title_pr1print: sta textptrhi
                ldy #$07
                jsr printtextc
                ldy #$09
                jmp printtextc

title_presents2:lda #<prtext2
                sta textptrlo
                lda #>prtext2
                bne title_pr1print

title_logo:     lda #90
                sta temp2
                lda #LVLSPRB
                sta temp3
                lda #$0c
                ldx #136
                ldy #$18
                jsr drl_setsprites
                jsr setlogocolors
                jmp sortsprites

printhiscore:   lda #<hstext
                sta textptrlo
                lda #>hstext
                sta textptrhi
                ldy #$02
                jsr printtextc
                jsr stmclearrow
                lda #$04
                sta temp1
                lda #$30
                sta temp2
                ldx #$00
title_hsloop:   ldy #$30
                inc temp2
                lda temp2
                cmp #$3a
                bcc title_hsnotover
                tya
                iny
title_hsnotover:sta textscreen+24*40+4
                tya
                sta textscreen+24*40+3
                ldy #$00
title_hsloop2:  lda hiscores,x
                sta textscreen+24*40+6,y
                inx
                iny
                cpy #$0c
                bcc title_hsloop2
                ldy #219
title_hsloop3:  lda hiscores,x
                jsr updp_drawdigits
                inx
                iny
                iny
                cpy #227
                bcc title_hsloop3
                stx temp3
                ldy temp1
                inc temp1
                jsr stmcopyrow
                ldx temp3
title_hsnotover2:
                cpx #160
                bcc title_hsloop
                rts

title_hiscore:  jsr printhiscore
                lda #$02
                jmp drawbigtm

fadeallrows:    ldx #SCROLLROWS
fadeallrows2:   stx title_fadecmp+1
                ldx #$00
title_hscolloop:jsr setrowcolor
                inx
title_fadecmp:  cpx #$00
                bcc title_hscolloop
                rts

title_credits:  lda #<crtext
                sta textptrlo
                lda #>crtext
                sta textptrhi
                ldx #$03
                ldy #$00
                jsr printtext
                iny
                iny
                jsr printtext
                ldx #$13
title_crloop1:  iny
                jsr printtext
                cpy #$0a
                bcc title_crloop1
                iny
                iny
                jsr printtextc
                iny
                iny
                jsr printtextc
                lda #$01
                bne drawbigtm

title_controls: lda #<controltext
                sta textptrlo
                lda #>controltext
                sta textptrhi
                ldy #$05
                jsr printtextc
                iny
                ldx #14
title_ctrlloop: iny
                jsr printtext
                cpy #$09
                bcc title_ctrlloop
                iny
                iny
                jsr printtextc
                lda #$00
                beq drawbigtm

title_contacts: lda #<contacttext
                sta textptrlo
                lda #>contacttext
                sta textptrhi
                ldy #$07
title_contactloop:
                jsr printtextc
                iny
                jmp printtextc

;Ŀ
;DRAWBIGTM                                                                    
;                                                                             
;Draws teammember picture                                                     
;(sprites)                                                                    
;                                                                             
;Parameters: A:Teammember number                                              
;Returns: -                                                                   
;Modifies: A,X,Y                                                              
;

drawbigtm:      asl
                asl
                asl
                sta temp3
                asl
                adc temp3
                adc #LVLSPRB+12
                sta temp3
                sta titlebigtmframe
                lda #59
                sta temp2
                lda #$18
                ldx #136
                ldy #$18
                jsr drl_setsprites
                jsr setbigtmcolors
                jmp sortsprites

dotitlefade:    lda titledurhi
                bne dtfi
                lda titledurlo
                cmp #$20
                bcc dtfo
dtfi:           ldx titlefade
                cpx #$10
                bcs dtfi_ready2
                inx
dtfi_ready:     sec
dtfi_ready3:    stx titlefade
                lda flashcolortbl,x
                rts
dtfo:           ldx titlefade
                beq dtfi_ready2
                dex
                jmp dtfi_ready
dtfi_ready2:    clc
                bcc dtfi_ready3

;Ŀ
;WAITANDUPDATE                                                                
;                                                                             
;Calls waitpanel, GETCONTROLS, TOGGLEMUSIC & UPDATEPANEL routines             
;                                                                             
;Parameters: -                                                                
;Returns: -                                                                   
;Modifies: A,X,Y,temp6                                                        
;
waitandupdate:  jsr waitpanel
                jsr getcontrols
                jsr togglemusic
                jmp updatepanel

;Ŀ
;WAITANDUPDATE_NOTOGGLE                                                       
;                                                                             
;Calls waitpanel, GETCONTROLS & UPDATEPANEL routines                          
;To not call TOGGLEMUSIC is important in situations like hiscore typing and   
;shops/conversations.                                                         
;                                                                             
;Parameters: -                                                                
;Returns: -                                                                   
;Modifies: A,X,Y,temp6                                                        
;

waitandupdate_notoggle:
                jsr waitpanel
                jsr getcontrols
                jmp updatepanel

;Ŀ
;MENU                                                                         
;                                                                             
;Menu loop                                                                    
;                                                                             
;Parameters: A:Menu selection                                                 
;              (If A negative, menu will never time out)                      
;            X:Number of choices                                              
;            Y:Position of first textrow                                      
;            textptrlo&textptrhi: text address                                
;Returns: A:Menu selection, C=0 not timed out, C=1 timed out                  
;Modifies: A,X,Y,temp1-temp5                                                  
;

menu:           pha
                and #$7f
                sta menuchoice
                pla
                and #$80
                sta menutimeout
                stx menuchoices
                sty temp5
                txa
                asl
                adc temp5
                sta menucmp1+1
                jsr cleartextscreen
                ldy temp5
                jsr printtextc
                txa
                sec
                sbc #$02
                sta menu_drawchar+1
                sta menu_erasechar+1
                iny
                iny
menutextloop:   jsr printtext
                iny
                iny
menucmp1:       cpy #$00
                bcc menutextloop
                lda #$00
                sta titlefade
menu_cleartime: lda #$00
                sta titledurlo
                sta titledurhi
menuloop:       lda menuchoice
                asl
                adc temp5
                tax
                lda screenrowtbllo,x
                sta temp3
                lda screenrowtblhi,x
                ora #>textscreen
                sta temp4
menu_drawchar:  ldy #$00
                lda #93
                sta (temp3),y
                jsr waitandupdate
                jsr menu_fadein
                lda joystick
                ora menutimeout
                bne menu_notimeout
                inc titledurlo
                bne menuloop
                inc titledurhi
                lda titledurhi
                cmp #$02
                bcs menu_timeout
                bcc menuloop
menu_notimeout: lda prevjoy
                bne menu_cleartime
                lda joystick
                and #JOY_UP
                beq menu_notup
                dec menuchoice
                bpl menu_erasechar
                ldx menuchoices
                dex
                stx menuchoice
menu_erasechar: ldy #$00
                lda #$20
                sta (temp3),y
                jmp menu_cleartime
menu_notup:     lda joystick
                and #JOY_DOWN
                beq menu_notdown
                inc menuchoice
                lda menuchoice
                cmp menuchoices
                bcc menu_erasechar
                lda #$00
                sta menuchoice
                beq menu_erasechar
menu_notdown:   jsr getfireclick
                bcs menu_fire
                jmp menu_cleartime
menu_fire:      clc
menu_timeout:   php
                jsr menu_fadeout
                plp
                lda menuchoice
                rts

menu_fadeout:   jsr waitandupdate
                jsr dtfo
                bcc menu_fadeoutdone
                jsr fadeallrows
                jmp menu_fadeout
menu_fadeoutdone:
menu_fadeindone:rts

ehsc_fadein:    jsr waitandupdate_notoggle
menu_fadein:    jsr dtfi
                bcc menu_fadeindone
                jmp fadeallrows

drl_setsprites: sta temp4
                stx temp5
                sty temp6
                ldx #$00
drl_loop1:      ldy #$04
                lda temp5
                sta temp1
drl_loop2:      lda temp1
                sta sprxl,x
                clc
                adc temp6
                sta temp1
                lda #$00
                sta sprxh,x
                lda temp2
                sta spry,x
                lda temp3
                sta sprf,x
                inc temp3
                inx
                dey
                bne drl_loop2
                lda temp2
                clc
                adc #21
                sta temp2
                cpx temp4
                bcc drl_loop1
                stx numsprites
                ldx #$00
                rts

setlogocolors:  txa
                lsr
                lsr
                ldx #12
                ldy #LVLSPRB
slc_common:     stx temp1
                tax
                lda #$ff
                sta $d01b                       ;Sprites behind BG
                lda logocolortbl,x
                sta $d025                       ;Set sprite multicolor 2
                lda logocolortbl+2,x
                sta $d026                       ;Set sprite multicolor 1
                lda logocolortbl+1,x
slc_loop:       sta sprcoltbl-$40,y
                iny
                dec temp1
                bne slc_loop
                rts

setbigtmcolors: txa
                lsr
                lsr
                cmp #$03
                bcc sbtc_ok
                lda #$03
sbtc_ok:        ldx #$18
                ldy titlebigtmframe
                jmp slc_common

;Ŀ
;SHOWINSTR                                                                    
;                                                                             
;Game instructions                                                            
;                                                                             
;Parameters: -                                                                
;Returns: -                                                                   
;Modifies: A,X,Y                                                              
;

showinstr:      jsr cleartextscreen
                lda #$02                        ;Load instructions file
                jsr loadfile
                lda #$ff                        ;Mark blocks overwritten
                sta loadedlevel
                lda #<instructions              ;Init text pointer
                sta textptrlo
                lda #>instructions
                sta textptrhi
                jsr st_display
instr_fadein:   jsr waitandupdate
                jsr menu_fadein
                lda titlefade
                cmp #$10
                bcc instr_fadein
instr_loop:     jsr waitandupdate
                ldy #208
                inc textptrhi
                inc textptrhi
                lda (textptrlo),y
                dec textptrhi
                dec textptrhi
                tax
                ldy #2
                lda joystick
                and #JOY_DOWN
                bne instr_scroll
                ldy #$00
                lda (textptrlo),y                 ;Upper limit of text?
                tax
                ldy #-2
                lda joystick
                and #JOY_UP
                beq instr_noscroll
instr_scroll:   cpx #$60
                bcs instr_noscroll
                tya
                jsr scrolltext
instr_noscroll: jsr getfireclick
                bcc instr_loop
                jmp menu_fadeout

;Ŀ
;SETBITMAPMODE                                                                
;                                                                             
;Activates bitmap mode for cutscenes!                                         
;                                                                             
;Parameters: -                                                                
;Returns: -                                                                   
;Modifies: A,X,Y                                                              
;

setbitmapmode:  jsr clearsprites
                jsr clearcutscenebitmap
                lda #58
sbmm_setsprites2:
                sta temp2
                lda #CUTSCENESPRB
                sta temp3
                lda #$14
                ldx #88
                ldy #$30
                jsr drl_setsprites
                lda #$01
                ldx #$13
sbmm_sprcolors: sta sprcoltbl+CUTSCENESPRB-$40,x
                dex
                bpl sbmm_sprcolors

clearcutscenesprites:
                ldy #$06
                lda #>cutscenesprites
                sta sbmm_clearsprites+2
                lda #$00
                tax
sbmm_clearsprites:sta cutscenesprites,x
                inx
                bne sbmm_clearsprites
                inc sbmm_clearsprites+2
                dey
                bne sbmm_clearsprites
                jmp sortsprites

clearcutscenebitmap:
                jsr waitpanel
                lda #$7f                        ;First set blanking-mode
                ldx #$00
                stx $d01b                       ;Sprites on top of BG
                ldy #TEXT_D018+$04
                jsr ctscommon
                jmp setsprmulticolor

;Ŀ
;DRAWBITMAP                                                                   
;                                                                             
;Cutscene bitmap draw routine                                                 
;                                                                             
;Parameters: temp1,temp2 picture address                                      
;            temp3,temp4 picture size (columns,rows)                          
;            temp5,temp6 picture destination pos.                             
;                                                                             
;Returns: -                                                                   
;Modifies: A,X,Y,various zeropage locations :-)                               
;

drawbitmap:     jsr waitpanel
                ldy #$00
                lda #$ff                                ;Init RLE depacker
                sta rlecount
                lda temp3                               ;Calculate length of
                asl                                     ;one picture row in
                asl                                     ;bytes
                asl
                sta dbm_bytecountlo+1
                tya
                rol
                sta dbm_bytecounthi+1
                lda #<320                               ;Calculate modulo
                sec
                sbc dbm_bytecountlo+1
                sta dbm_modulolo+1
                lda #>320
                sbc dbm_bytecounthi+1
                sta dbm_modulohi+1
                lda #<bitmap                            ;Find bitmap position
                sta textptrlo
                lda #>bitmap
                sta textptrhi
                lda temp6
                beq dbm_bitmapposyready
                sta temp7
dbm_bitmapposyloop:
                lda textptrlo
                clc
                adc #<320
                sta textptrlo
                lda textptrhi
                adc #>320
                sta textptrhi
                dec temp7
                bne dbm_bitmapposyloop
dbm_bitmapposyready:
                lda temp5
                beq dbm_bitmapposxready
                sta temp7
dbm_bitmapposxloop:
                lda textptrlo
                clc
                adc #$08
                sta textptrlo
                bcc dbm_bitmapposxnotover
                inc textptrhi
dbm_bitmapposxnotover:
                dec temp7
                bne dbm_bitmapposxloop
dbm_bitmapposxready:
                jsr dbm_subroutine                      ;First draw bitmap
                lda #$00
                sta dbm_bytecounthi+1
                sta dbm_modulohi+1
                lda temp3
                sta dbm_bytecountlo+1
                lda #40
                sec
                sbc temp3
                sta dbm_modulolo+1
                ldx temp6
                lda screenrowtbllo,x
                clc
                adc temp5
                sta textptrlo
                pha
                lda screenrowtblhi,x
                adc #$00
                ora #>screen1
                sta textptrhi
                pha
                jsr dbm_subroutine                      ;Then screen
                pla
                clc
                adc #(>colors)-(>screen1)
                sta textptrhi
                pla
                sta textptrlo                           ;Then colorscreen
                jsr dbm_subroutine
                lda temp4                               ;If negative, don't
                bmi dbm_skipshow                        ;yet unblank
                lda #$3f                                ;Unblank bitmap
                sta textscrolly+1                       ;screen
dbm_skipshow:   rts

dbm_subroutine: lda temp4
                and #$7f
                sta temp7
dbm_rowloop:
dbm_bytecountlo:lda #$00
                sta mapptrlo
dbm_bytecounthi:lda #$00
                sta mapptrhi
dbm_byteloop:   lda rlecount                            ;Get new control byte?
                bpl dbm_nonewctrl
                jsr dbm_getbyte
                pha
                and #$7f
                sta rlecount
                pla
                and #$80
                sta rlemode
                beq dbm_nonewctrl
                jsr dbm_getbyte
                sta dbm_rle+1
dbm_nonewctrl:  lda rlemode
                bne dbm_rle
                jsr dbm_getbyte
                jmp dbm_bytedone
dbm_rle:        lda #$00
dbm_bytedone:   dec rlecount
                sta (textptrlo),y                           ;Store bitmap data
                inc textptrlo
                bne dbm_notover1
                inc textptrhi
dbm_notover1:   lda mapptrlo
                bne dbm_notover2
                dec mapptrhi
dbm_notover2:   dec mapptrlo
                lda mapptrlo                            ;Byte count zero?
                ora mapptrhi
                bne dbm_byteloop
                lda textptrlo                           ;Add modulo and move
                clc                                     ;to next row
dbm_modulolo:   adc #$00
                sta textptrlo
                lda textptrhi
dbm_modulohi:   adc #$00
                sta textptrhi
                dec temp7                               ;Row count zero?
                bne dbm_rowloop
                rts

dbm_getbyte:    lda (temp1),y
                inc temp1
                bne dbm_getbytedone
                inc temp2
dbm_getbytedone:rts

;Ŀ
;DRAWSPRCHAR                                                                  
;                                                                             
;Draws a char to the cutscene sprites.                                        
;                                                                             
;Parameters: A:Char                                                           
;            X:X position                                                     
;            Y:Y position                                                     
;                                                                             
;Returns: -                                                                   
;Modifies: A,X,Y,temp1,temp2                                                  
;

drawsprchar:    and #$3f
                eor #$20
                asl
                sta temp1
                asl
                adc temp1
                sta wsc_lda+1
                lda #>cutscenefonts
                adc #$00
                sta wsc_lda+2
                lda #<cutscenesprites
                sta temp1
                lda #>cutscenesprites
                sta temp2

                cpy #15
                bne wsc_yloop
                lda #>(cutscenesprites+5*256)
                sta temp2
                ldy #$00

wsc_yloop:      dey
                bmi wsc_ydone
                lda #7*3
                jsr wsc_add
                dey
                bmi wsc_ydone
                lda #7*3
                jsr wsc_add
                dey
                bmi wsc_ydone
                lda #214
                jsr wsc_add
                jmp wsc_yloop

wsc_ydone:      txa
                lsr
                tax
                lda #$00
                rol
                sta wsc_xfine+1

wsc_xloop:      dex
                bmi wsc_xdone
                lda #1
                jsr wsc_add
                dex
                bmi wsc_xdone
                lda #1
                jsr wsc_add
                dex
                bmi wsc_xdone
                lda #62
                jsr wsc_add
                jmp wsc_xloop

wsc_xdone:
wsc_chrloop:    iny
                inx
wsc_xfine:      lda #$00
                ror
wsc_lda:        lda $1000,x
                bcs wsc_noshift
                asl
                asl
                asl
                asl
wsc_noshift:    ora (temp1),y
                sta (temp1),y
                iny
                iny
                cpx #$05
                bcc wsc_chrloop
                rts

wsc_add:        clc
                adc temp1
                sta temp1
                bcc wsc_adddone
                inc temp2
wsc_adddone:    rts

